/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v57</h1>       <p>Introduced in Cloudera Manager 7.13.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 7.13.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package com.cloudera.api.swagger.model;

import java.util.Objects;
import java.util.Arrays;
import io.swagger.v3.oas.annotations.media.Schema;
import com.google.gson.annotations.SerializedName;
import java.io.IOException;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * The single value used by the Cloudera Manager UI to represent the status of the entity. It is computed from a variety of other entity-specific states, not all values apply to all entities. For example, STARTING/STOPPING do not apply to a host.
 */
@JsonAdapter(ApiEntityStatus.Adapter.class)
public enum ApiEntityStatus {
  @SerializedName("UNKNOWN")
  UNKNOWN("UNKNOWN"),
  @SerializedName("NONE")
  NONE("NONE"),
  @SerializedName("STOPPED")
  STOPPED("STOPPED"),
  @SerializedName("DOWN")
  DOWN("DOWN"),
  @SerializedName("UNKNOWN_HEALTH")
  UNKNOWN_HEALTH("UNKNOWN_HEALTH"),
  @SerializedName("DISABLED_HEALTH")
  DISABLED_HEALTH("DISABLED_HEALTH"),
  @SerializedName("CONCERNING_HEALTH")
  CONCERNING_HEALTH("CONCERNING_HEALTH"),
  @SerializedName("BAD_HEALTH")
  BAD_HEALTH("BAD_HEALTH"),
  @SerializedName("GOOD_HEALTH")
  GOOD_HEALTH("GOOD_HEALTH"),
  @SerializedName("STARTING")
  STARTING("STARTING"),
  @SerializedName("STOPPING")
  STOPPING("STOPPING"),
  @SerializedName("HISTORY_NOT_AVAILABLE")
  HISTORY_NOT_AVAILABLE("HISTORY_NOT_AVAILABLE");

  private String value;

  ApiEntityStatus(String value) {
    this.value = value;
  }

  public String getValue() {
    return value;
  }

  @Override
  public String toString() {
    return String.valueOf(value);
  }

  public static ApiEntityStatus fromValue(String input) {
    for (ApiEntityStatus b : ApiEntityStatus.values()) {
      if (b.value.equals(input)) {
        return b;
      }
    }
    return null;
  }

  public static class Adapter extends TypeAdapter<ApiEntityStatus> {
    @Override
    public void write(final JsonWriter jsonWriter, final ApiEntityStatus enumeration) throws IOException {
      jsonWriter.value(String.valueOf(enumeration.getValue()));
    }

    @Override
    public ApiEntityStatus read(final JsonReader jsonReader) throws IOException {
      Object value = jsonReader.nextString();
      return ApiEntityStatus.fromValue((String)(value));
    }
  }
}
