/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v57</h1>       <p>Introduced in Cloudera Manager 7.13.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 7.13.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package com.cloudera.api.swagger.model;

import java.util.Objects;
import java.util.Arrays;
import com.cloudera.api.swagger.model.ApiServiceRef;
import com.cloudera.api.swagger.model.HBaseDatabaseArgs;
import com.cloudera.api.swagger.model.HBasePeerState;
import com.cloudera.api.swagger.model.HBaseTableArgs;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
/**
 * Replication arguments for HBase service
 */
@Schema(description = "Replication arguments for HBase service")
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2024-12-03T04:57:51.616Z[Etc/UTC]")

public class ApiHBaseReplicationArguments {
  @SerializedName("sourceHBaseService")
  private ApiServiceRef sourceHBaseService = null;

  @SerializedName("peerState")
  private HBasePeerState peerState = null;

  @SerializedName("hbasePeerId")
  private String hbasePeerId = null;

  @SerializedName("hbaseClusterKey")
  private String hbaseClusterKey = null;

  @SerializedName("endPointClassName")
  private String endPointClassName = null;

  @SerializedName("tables")
  private List<HBaseTableArgs> tables = null;

  @SerializedName("database")
  private HBaseDatabaseArgs database = null;

  @SerializedName("replicationProperties")
  private Map<String, String> replicationProperties = null;

  @SerializedName("sourceAccount")
  private String sourceAccount = null;

  @SerializedName("sourceSchedulerPool")
  private String sourceSchedulerPool = null;

  @SerializedName("numMappers")
  private java.math.BigDecimal numMappers = null;

  @SerializedName("bandwidthPerMap")
  private java.math.BigDecimal bandwidthPerMap = null;

  @SerializedName("exportSnapshotUser")
  private String exportSnapshotUser = null;

  @SerializedName("snapshotScratchLocation")
  private String snapshotScratchLocation = null;

  @SerializedName("validateReplicationSetup")
  private Boolean validateReplicationSetup = null;

  @SerializedName("maxParallelSnapshots")
  private java.math.BigDecimal maxParallelSnapshots = null;

  public ApiHBaseReplicationArguments sourceHBaseService(ApiServiceRef sourceHBaseService) {
    this.sourceHBaseService = sourceHBaseService;
    return this;
  }

   /**
   * Get sourceHBaseService
   * @return sourceHBaseService
  **/
  @Schema(description = "")
  public ApiServiceRef getSourceHBaseService() {
    return sourceHBaseService;
  }

  public void setSourceHBaseService(ApiServiceRef sourceHBaseService) {
    this.sourceHBaseService = sourceHBaseService;
  }

  public ApiHBaseReplicationArguments peerState(HBasePeerState peerState) {
    this.peerState = peerState;
    return this;
  }

   /**
   * Get peerState
   * @return peerState
  **/
  @Schema(description = "")
  public HBasePeerState getPeerState() {
    return peerState;
  }

  public void setPeerState(HBasePeerState peerState) {
    this.peerState = peerState;
  }

  public ApiHBaseReplicationArguments hbasePeerId(String hbasePeerId) {
    this.hbasePeerId = hbasePeerId;
    return this;
  }

   /**
   * Available since API v52.
   * @return hbasePeerId
  **/
  @Schema(description = "Available since API v52.")
  public String getHbasePeerId() {
    return hbasePeerId;
  }

  public void setHbasePeerId(String hbasePeerId) {
    this.hbasePeerId = hbasePeerId;
  }

  public ApiHBaseReplicationArguments hbaseClusterKey(String hbaseClusterKey) {
    this.hbaseClusterKey = hbaseClusterKey;
    return this;
  }

   /**
   * Get hbaseClusterKey
   * @return hbaseClusterKey
  **/
  @Schema(description = "")
  public String getHbaseClusterKey() {
    return hbaseClusterKey;
  }

  public void setHbaseClusterKey(String hbaseClusterKey) {
    this.hbaseClusterKey = hbaseClusterKey;
  }

  public ApiHBaseReplicationArguments endPointClassName(String endPointClassName) {
    this.endPointClassName = endPointClassName;
    return this;
  }

   /**
   * Get endPointClassName
   * @return endPointClassName
  **/
  @Schema(description = "")
  public String getEndPointClassName() {
    return endPointClassName;
  }

  public void setEndPointClassName(String endPointClassName) {
    this.endPointClassName = endPointClassName;
  }

  public ApiHBaseReplicationArguments tables(List<HBaseTableArgs> tables) {
    this.tables = tables;
    return this;
  }

  public ApiHBaseReplicationArguments addTablesItem(HBaseTableArgs tablesItem) {
    if (this.tables == null) {
      this.tables = new ArrayList<>();
    }
    this.tables.add(tablesItem);
    return this;
  }

   /**
   * Get tables
   * @return tables
  **/
  @Schema(description = "")
  public List<HBaseTableArgs> getTables() {
    return tables;
  }

  public void setTables(List<HBaseTableArgs> tables) {
    this.tables = tables;
  }

  public ApiHBaseReplicationArguments database(HBaseDatabaseArgs database) {
    this.database = database;
    return this;
  }

   /**
   * Get database
   * @return database
  **/
  @Schema(description = "")
  public HBaseDatabaseArgs getDatabase() {
    return database;
  }

  public void setDatabase(HBaseDatabaseArgs database) {
    this.database = database;
  }

  public ApiHBaseReplicationArguments replicationProperties(Map<String, String> replicationProperties) {
    this.replicationProperties = replicationProperties;
    return this;
  }

  public ApiHBaseReplicationArguments putReplicationPropertiesItem(String key, String replicationPropertiesItem) {
    if (this.replicationProperties == null) {
      this.replicationProperties = new HashMap<>();
    }
    this.replicationProperties.put(key, replicationPropertiesItem);
    return this;
  }

   /**
   * Get replicationProperties
   * @return replicationProperties
  **/
  @Schema(description = "")
  public Map<String, String> getReplicationProperties() {
    return replicationProperties;
  }

  public void setReplicationProperties(Map<String, String> replicationProperties) {
    this.replicationProperties = replicationProperties;
  }

  public ApiHBaseReplicationArguments sourceAccount(String sourceAccount) {
    this.sourceAccount = sourceAccount;
    return this;
  }

   /**
   * Get sourceAccount
   * @return sourceAccount
  **/
  @Schema(description = "")
  public String getSourceAccount() {
    return sourceAccount;
  }

  public void setSourceAccount(String sourceAccount) {
    this.sourceAccount = sourceAccount;
  }

  public ApiHBaseReplicationArguments sourceSchedulerPool(String sourceSchedulerPool) {
    this.sourceSchedulerPool = sourceSchedulerPool;
    return this;
  }

   /**
   * Get sourceSchedulerPool
   * @return sourceSchedulerPool
  **/
  @Schema(description = "")
  public String getSourceSchedulerPool() {
    return sourceSchedulerPool;
  }

  public void setSourceSchedulerPool(String sourceSchedulerPool) {
    this.sourceSchedulerPool = sourceSchedulerPool;
  }

  public ApiHBaseReplicationArguments numMappers(java.math.BigDecimal numMappers) {
    this.numMappers = numMappers;
    return this;
  }

   /**
   * Get numMappers
   * @return numMappers
  **/
  @Schema(description = "")
  public java.math.BigDecimal getNumMappers() {
    return numMappers;
  }

  public void setNumMappers(java.math.BigDecimal numMappers) {
    this.numMappers = numMappers;
  }

  public ApiHBaseReplicationArguments bandwidthPerMap(java.math.BigDecimal bandwidthPerMap) {
    this.bandwidthPerMap = bandwidthPerMap;
    return this;
  }

   /**
   * Get bandwidthPerMap
   * @return bandwidthPerMap
  **/
  @Schema(description = "")
  public java.math.BigDecimal getBandwidthPerMap() {
    return bandwidthPerMap;
  }

  public void setBandwidthPerMap(java.math.BigDecimal bandwidthPerMap) {
    this.bandwidthPerMap = bandwidthPerMap;
  }

  public ApiHBaseReplicationArguments exportSnapshotUser(String exportSnapshotUser) {
    this.exportSnapshotUser = exportSnapshotUser;
    return this;
  }

   /**
   * Get exportSnapshotUser
   * @return exportSnapshotUser
  **/
  @Schema(description = "")
  public String getExportSnapshotUser() {
    return exportSnapshotUser;
  }

  public void setExportSnapshotUser(String exportSnapshotUser) {
    this.exportSnapshotUser = exportSnapshotUser;
  }

  public ApiHBaseReplicationArguments snapshotScratchLocation(String snapshotScratchLocation) {
    this.snapshotScratchLocation = snapshotScratchLocation;
    return this;
  }

   /**
   * Get snapshotScratchLocation
   * @return snapshotScratchLocation
  **/
  @Schema(description = "")
  public String getSnapshotScratchLocation() {
    return snapshotScratchLocation;
  }

  public void setSnapshotScratchLocation(String snapshotScratchLocation) {
    this.snapshotScratchLocation = snapshotScratchLocation;
  }

  public ApiHBaseReplicationArguments validateReplicationSetup(Boolean validateReplicationSetup) {
    this.validateReplicationSetup = validateReplicationSetup;
    return this;
  }

   /**
   * Get validateReplicationSetup
   * @return validateReplicationSetup
  **/
  @Schema(description = "")
  public Boolean isValidateReplicationSetup() {
    return validateReplicationSetup;
  }

  public void setValidateReplicationSetup(Boolean validateReplicationSetup) {
    this.validateReplicationSetup = validateReplicationSetup;
  }

  public ApiHBaseReplicationArguments maxParallelSnapshots(java.math.BigDecimal maxParallelSnapshots) {
    this.maxParallelSnapshots = maxParallelSnapshots;
    return this;
  }

   /**
   * Get maxParallelSnapshots
   * @return maxParallelSnapshots
  **/
  @Schema(description = "")
  public java.math.BigDecimal getMaxParallelSnapshots() {
    return maxParallelSnapshots;
  }

  public void setMaxParallelSnapshots(java.math.BigDecimal maxParallelSnapshots) {
    this.maxParallelSnapshots = maxParallelSnapshots;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiHBaseReplicationArguments apiHBaseReplicationArguments = (ApiHBaseReplicationArguments) o;
    return Objects.equals(this.sourceHBaseService, apiHBaseReplicationArguments.sourceHBaseService) &&
        Objects.equals(this.peerState, apiHBaseReplicationArguments.peerState) &&
        Objects.equals(this.hbasePeerId, apiHBaseReplicationArguments.hbasePeerId) &&
        Objects.equals(this.hbaseClusterKey, apiHBaseReplicationArguments.hbaseClusterKey) &&
        Objects.equals(this.endPointClassName, apiHBaseReplicationArguments.endPointClassName) &&
        Objects.equals(this.tables, apiHBaseReplicationArguments.tables) &&
        Objects.equals(this.database, apiHBaseReplicationArguments.database) &&
        Objects.equals(this.replicationProperties, apiHBaseReplicationArguments.replicationProperties) &&
        Objects.equals(this.sourceAccount, apiHBaseReplicationArguments.sourceAccount) &&
        Objects.equals(this.sourceSchedulerPool, apiHBaseReplicationArguments.sourceSchedulerPool) &&
        Objects.equals(this.numMappers, apiHBaseReplicationArguments.numMappers) &&
        Objects.equals(this.bandwidthPerMap, apiHBaseReplicationArguments.bandwidthPerMap) &&
        Objects.equals(this.exportSnapshotUser, apiHBaseReplicationArguments.exportSnapshotUser) &&
        Objects.equals(this.snapshotScratchLocation, apiHBaseReplicationArguments.snapshotScratchLocation) &&
        Objects.equals(this.validateReplicationSetup, apiHBaseReplicationArguments.validateReplicationSetup) &&
        Objects.equals(this.maxParallelSnapshots, apiHBaseReplicationArguments.maxParallelSnapshots);
  }

  @Override
  public int hashCode() {
    return Objects.hash(sourceHBaseService, peerState, hbasePeerId, hbaseClusterKey, endPointClassName, tables, database, replicationProperties, sourceAccount, sourceSchedulerPool, numMappers, bandwidthPerMap, exportSnapshotUser, snapshotScratchLocation, validateReplicationSetup, maxParallelSnapshots);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiHBaseReplicationArguments {\n");
    
    sb.append("    sourceHBaseService: ").append(toIndentedString(sourceHBaseService)).append("\n");
    sb.append("    peerState: ").append(toIndentedString(peerState)).append("\n");
    sb.append("    hbasePeerId: ").append(toIndentedString(hbasePeerId)).append("\n");
    sb.append("    hbaseClusterKey: ").append(toIndentedString(hbaseClusterKey)).append("\n");
    sb.append("    endPointClassName: ").append(toIndentedString(endPointClassName)).append("\n");
    sb.append("    tables: ").append(toIndentedString(tables)).append("\n");
    sb.append("    database: ").append(toIndentedString(database)).append("\n");
    sb.append("    replicationProperties: ").append(toIndentedString(replicationProperties)).append("\n");
    sb.append("    sourceAccount: ").append(toIndentedString(sourceAccount)).append("\n");
    sb.append("    sourceSchedulerPool: ").append(toIndentedString(sourceSchedulerPool)).append("\n");
    sb.append("    numMappers: ").append(toIndentedString(numMappers)).append("\n");
    sb.append("    bandwidthPerMap: ").append(toIndentedString(bandwidthPerMap)).append("\n");
    sb.append("    exportSnapshotUser: ").append(toIndentedString(exportSnapshotUser)).append("\n");
    sb.append("    snapshotScratchLocation: ").append(toIndentedString(snapshotScratchLocation)).append("\n");
    sb.append("    validateReplicationSetup: ").append(toIndentedString(validateReplicationSetup)).append("\n");
    sb.append("    maxParallelSnapshots: ").append(toIndentedString(maxParallelSnapshots)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
