/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v57</h1>       <p>Introduced in Cloudera Manager 7.13.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 7.13.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package com.cloudera.api.swagger.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
/**
 * Arguments for transforming HDFS Ranger service policies to Azure Data Lake Storage (ADLS) policies. &lt;p&gt; Note that it&#x27;s relevant only if any of the Ranger services to be replicated contain HDFS Ranger service type and replication will be done from on-prem to ADLS.
 */
@Schema(description = "Arguments for transforming HDFS Ranger service policies to Azure Data Lake Storage (ADLS) policies. <p> Note that it's relevant only if any of the Ranger services to be replicated contain HDFS Ranger service type and replication will be done from on-prem to ADLS.")
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2024-12-03T04:57:51.616Z[Etc/UTC]")

public class ApiRangerReplicationHdfsToAdlsArgs {
  @SerializedName("adlsStorageAccount")
  private String adlsStorageAccount = null;

  @SerializedName("adlsStorageAccountContainer")
  private String adlsStorageAccountContainer = null;

  public ApiRangerReplicationHdfsToAdlsArgs adlsStorageAccount(String adlsStorageAccount) {
    this.adlsStorageAccount = adlsStorageAccount;
    return this;
  }

   /**
   * ADLS storage account name for Ranger HDFS policies which need to be transformed to ADLS policy.
   * @return adlsStorageAccount
  **/
  @Schema(description = "ADLS storage account name for Ranger HDFS policies which need to be transformed to ADLS policy.")
  public String getAdlsStorageAccount() {
    return adlsStorageAccount;
  }

  public void setAdlsStorageAccount(String adlsStorageAccount) {
    this.adlsStorageAccount = adlsStorageAccount;
  }

  public ApiRangerReplicationHdfsToAdlsArgs adlsStorageAccountContainer(String adlsStorageAccountContainer) {
    this.adlsStorageAccountContainer = adlsStorageAccountContainer;
    return this;
  }

   /**
   * ADLS storage account container name for Ranger HDFS policies which need to be transformed to ADLS policy.
   * @return adlsStorageAccountContainer
  **/
  @Schema(description = "ADLS storage account container name for Ranger HDFS policies which need to be transformed to ADLS policy.")
  public String getAdlsStorageAccountContainer() {
    return adlsStorageAccountContainer;
  }

  public void setAdlsStorageAccountContainer(String adlsStorageAccountContainer) {
    this.adlsStorageAccountContainer = adlsStorageAccountContainer;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiRangerReplicationHdfsToAdlsArgs apiRangerReplicationHdfsToAdlsArgs = (ApiRangerReplicationHdfsToAdlsArgs) o;
    return Objects.equals(this.adlsStorageAccount, apiRangerReplicationHdfsToAdlsArgs.adlsStorageAccount) &&
        Objects.equals(this.adlsStorageAccountContainer, apiRangerReplicationHdfsToAdlsArgs.adlsStorageAccountContainer);
  }

  @Override
  public int hashCode() {
    return Objects.hash(adlsStorageAccount, adlsStorageAccountContainer);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiRangerReplicationHdfsToAdlsArgs {\n");
    
    sb.append("    adlsStorageAccount: ").append(toIndentedString(adlsStorageAccount)).append("\n");
    sb.append("    adlsStorageAccountContainer: ").append(toIndentedString(adlsStorageAccountContainer)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
