/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v57</h1>       <p>Introduced in Cloudera Manager 7.13.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 7.13.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package com.cloudera.api.swagger.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
/**
 * Metadata about a YARN application attribute.
 */
@Schema(description = "Metadata about a YARN application attribute.")
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2024-12-03T04:57:51.616Z[Etc/UTC]")

public class ApiYarnApplicationAttribute {
  @SerializedName("name")
  private String name = null;

  @SerializedName("type")
  private String type = null;

  @SerializedName("displayName")
  private String displayName = null;

  @SerializedName("supportsHistograms")
  private Boolean supportsHistograms = null;

  @SerializedName("description")
  private String description = null;

  public ApiYarnApplicationAttribute name(String name) {
    this.name = name;
    return this;
  }

   /**
   * The name of the attribute. This name can be used in filters, for example &#x27;user&#x27; could be used in the filter &#x27;user &#x3D; root&#x27;.
   * @return name
  **/
  @Schema(description = "The name of the attribute. This name can be used in filters, for example 'user' could be used in the filter 'user = root'.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public ApiYarnApplicationAttribute type(String type) {
    this.type = type;
    return this;
  }

   /**
   * The type of the attribute. Valid types are STRING, NUMBER, BOOLEAN, BYTES, MILLISECONDS, BYTES_PER_SECOND, BYTE_SECONDS.
   * @return type
  **/
  @Schema(description = "The type of the attribute. Valid types are STRING, NUMBER, BOOLEAN, BYTES, MILLISECONDS, BYTES_PER_SECOND, BYTE_SECONDS.")
  public String getType() {
    return type;
  }

  public void setType(String type) {
    this.type = type;
  }

  public ApiYarnApplicationAttribute displayName(String displayName) {
    this.displayName = displayName;
    return this;
  }

   /**
   * The display name for the attribute.
   * @return displayName
  **/
  @Schema(description = "The display name for the attribute.")
  public String getDisplayName() {
    return displayName;
  }

  public void setDisplayName(String displayName) {
    this.displayName = displayName;
  }

  public ApiYarnApplicationAttribute supportsHistograms(Boolean supportsHistograms) {
    this.supportsHistograms = supportsHistograms;
    return this;
  }

   /**
   * Whether the Service Monitor can generate a histogram of the distribution of the attribute across applications.
   * @return supportsHistograms
  **/
  @Schema(description = "Whether the Service Monitor can generate a histogram of the distribution of the attribute across applications.")
  public Boolean isSupportsHistograms() {
    return supportsHistograms;
  }

  public void setSupportsHistograms(Boolean supportsHistograms) {
    this.supportsHistograms = supportsHistograms;
  }

  public ApiYarnApplicationAttribute description(String description) {
    this.description = description;
    return this;
  }

   /**
   * The description of the attribute.
   * @return description
  **/
  @Schema(description = "The description of the attribute.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiYarnApplicationAttribute apiYarnApplicationAttribute = (ApiYarnApplicationAttribute) o;
    return Objects.equals(this.name, apiYarnApplicationAttribute.name) &&
        Objects.equals(this.type, apiYarnApplicationAttribute.type) &&
        Objects.equals(this.displayName, apiYarnApplicationAttribute.displayName) &&
        Objects.equals(this.supportsHistograms, apiYarnApplicationAttribute.supportsHistograms) &&
        Objects.equals(this.description, apiYarnApplicationAttribute.description);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, type, displayName, supportsHistograms, description);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiYarnApplicationAttribute {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    displayName: ").append(toIndentedString(displayName)).append("\n");
    sb.append("    supportsHistograms: ").append(toIndentedString(supportsHistograms)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
