# ApiGenerateCmcaArguments

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**location** | **String** | The location on disk to store the CMCA directory. If there is already a CMCA created there, it will be backed up, and a new one will be created in its place. |  [optional]
**customCA** | **Boolean** | Whether to generate an internal CMCA (false) or use user-provided certificates (true).  When set to true (user-provided certificates), the following other arguments must be given: * cmHostCert * cmHostKey * caCert * keystorePasswd * truststorePasswd |  [optional]
**interpretAsFilenames** | **Boolean** | Whether the following arguments are interpreted as filenames local to the Cloudera Manager host (true, default) or as the actual data for that argument: * cmHostCert * cmHostKey * caCert * keystorePasswd * truststorePasswd * trustedCaCerts * hostCerts.hostCert * hostCerts.hostKey  If HTTPS has not been enabled on the Cloudera Manager Admin Console and API, we *strongly* recommend that you pass the arguments as filenames local to the Cloudera Manager host (i.e. set to true) to avoid leaking sensitive information over the wire in plaintext. |  [optional]
**cmHostCert** | **String** | The certificate for the CM host in PEM format. Only used if customCA &#x3D;&#x3D; true. |  [optional]
**cmHostKey** | **String** | The private key for the CM host in PEM format. Only used if customCA &#x3D;&#x3D; true. |  [optional]
**caCert** | **String** | The certificate for the user-provided certificate authority in PEM format. Only used if customCA &#x3D;&#x3D; true. |  [optional]
**keystorePasswd** | **String** | The password used for all Auto-TLS keystores. Only used if customCA &#x3D;&#x3D; true. |  [optional]
**truststorePasswd** | **String** | The password used for all Auto-TLS truststores. Only used if customCA &#x3D;&#x3D; true. |  [optional]
**trustedCaCerts** | **String** | A list of CA certificates that will be imported into the Auto-TLS truststore and distributed to all hosts. |  [optional]
**additionalArguments** | **List&lt;String&gt;** | A list of additional arguments that can be passed to the certificate manager |  [optional]
**hostCerts** | [**List&lt;ApiHostCertInfo&gt;**](ApiHostCertInfo.md) | A list of HostCertInfo objects, which associate a hostname with the corresponding certificate and private key. Only used if customCA &#x3D;&#x3D; true. |  [optional]
**configureAllServices** | **Boolean** | Whether to configure all existing services to use Auto-TLS. Defaults to false.  If false, only MGMT services will be configured to use Auto-TLS. Use the cluster-level ConfigureAutoTlsServices command to configure Auto-TLS services for a single cluster only.  All future services will be configured to use Auto-TLS regardless of this setting. |  [optional]
