# ApiHiveCloudReplicationArguments

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**exportFilesPrefix** | **String** | When a Hive external cloud replication schedule was executed, then the exported files had the same name under the given cloud root path. Therefore, it was forbidden to concurrently execute multiple Hive external replications with the same cloud root path. &lt;br&gt;  This field is meant to lift this restriction: it contains a prefix name that will be prepended to every export file, by default it is set to a UUID for a replication schedule. &lt;br&gt;  &lt;b&gt;Note that this feature is available only if feature flag HIVE_ALLOW_CONCURRENT_REPLICATION_WITH_SAME_CLOUD_ROOT_PATH is enabled on both source and destination! It&#x27;s NOT supported for cloud backup only and cloud restore only replications.&lt;/b&gt; &lt;br&gt;  For instance if #cloudRootPath &#x3D;&#x3D; s3a://bucket/warehouse/external/my_db and #exportFilesPrefix &#x3D;&#x3D; ab58c108, then after a successful replication the following export files will be in the cloud: &lt;ul&gt; &lt;li&gt;s3a://bucket/warehouse/external/my_db/ab58c108export.json&lt;/li&gt; &lt;li&gt;s3a://bucket/warehouse/external/my_db/ab58c108.export.json.meta&lt;/li&gt; &lt;li&gt;s3a://bucket/warehouse/external/my_db/ab58c108sentry-export.json&lt;/li&gt; &lt;/ul&gt; In the next replication run the same UUID will be used for a certain schedule as before, so the same export files will be overwritten in the cloud. This way the cloud root path won&#x27;t be polluted. |  [optional]
**sourceAccount** | **String** |  |  [optional]
**destinationAccount** | **String** |  |  [optional]
**cloudRootPath** | **String** |  |  [optional]
**replicationOption** | [**ReplicationOption**](ReplicationOption.md) |  |  [optional]
