# ApiHiveReplicationArguments

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**sourceService** | [**ApiServiceRef**](ApiServiceRef.md) |  |  [optional]
**tableFilters** | [**List&lt;ApiHiveTable&gt;**](ApiHiveTable.md) | Filters for tables to include in the replication. Optional. If not provided, include all tables in all databases. |  [optional]
**exportDir** | **String** | Directory, in the HDFS service where the target Hive service&#x27;s data is stored, where the export file will be saved. Optional. If not provided, Cloudera Manager will pick a directory for storing the data. |  [optional]
**force** | **Boolean** | Whether to force overwriting of mismatched tables. Defaults to false. |  [optional]
**replicateData** | **Boolean** | Whether to replicate table data stored in HDFS. Defaults to false. &lt;p/&gt; If set, the \&quot;hdfsArguments\&quot; property must be set to configure the HDFS replication job. |  [optional]
**hdfsArguments** | [**ApiHdfsReplicationArguments**](ApiHdfsReplicationArguments.md) |  |  [optional]
**replicateImpalaMetadata** | **Boolean** | Whether to replicate the impala metadata. (i.e. the metadata for impala UDFs and their corresponding binaries in HDFS). |  [optional]
**runInvalidateMetadata** | **Boolean** | Whether to run invalidate metadata query or not |  [optional]
**dryRun** | **Boolean** | Whether to perform a dry run. Defaults to false |  [optional]
**numThreads** | **java.math.BigDecimal** | Number of threads to use in multi-threaded export/import phase |  [optional]
**sentryMigration** | **Boolean** |  | 
**skipUrlPermissions** | **Boolean** | Is skipUrlPermissions on. | 
**atlasReplicationNeeded** | **Boolean** |  |  [optional]
**sentryExportProperties** | **Map&lt;String, String&gt;** | Additional properties to add or override in authorization-migration-site.xml for Sentry export, on the source. |  [optional]
**rangerImportProperties** | **Map&lt;String, String&gt;** | Additional properties to add or override in authorization-migration-site.xml for Ranger import, on the destination. |  [optional]
