# ApiRangerReplicationTransformArgs

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**rangerServiceNamesMapping** | **Map&lt;String, String&gt;** | A mapping between source to destination ranger services. &lt;p&gt; Note that if a mapping is not given for a service then it will stay the same on the destination. &lt;p&gt; Example: {\&quot;cm_hdfs\&quot;:\&quot;dr_hdfs\&quot;, \&quot;cm_hive\&quot;:\&quot;dr_hive\&quot;} &lt;br&gt; Default: empty or null, every service name will stay the same on the destination |  [optional]
**rangerUsersMapping** | **Map&lt;String, String&gt;** | A mapping between source to destination ranger usernames. &lt;p&gt; Note that if a mapping is not given for a username then it will stay the same on the destination. &lt;p&gt; Example: {\&quot;testuser1\&quot;:\&quot;testuser1@host.com\&quot;, \&quot;testuser2\&quot;:\&quot;testuser2@host.com\&quot; }&lt;br&gt; Default: empty or null, every username will stay the same on the destination |  [optional]
**rangerResourcesMapping** | **Map&lt;String, String&gt;** | A mapping between source to destination ranger resources. &lt;p&gt; If a mapping is not given for a resource then it will stay the same on the destination. &lt;p&gt; &lt;b&gt;Example&lt;/b&gt;: &lt;br&gt; {\&quot;/srcdir1/srcfile1\&quot;: \&quot;/destdir1/destfile1\&quot;, \&quot;src_url.com\&quot;: \&quot;dest_url.com\&quot;, \&quot;source_db\&quot;: \&quot;dest_db\&quot;, \&quot;source_table\&quot;:\&quot;dest_table\&quot;} } &lt;br&gt; Default: empty or null, every resource will remain the same on destination &lt;p&gt; If replication contains &lt;b&gt;HDFS Ranger service type&lt;/b&gt; and replication is done from on-prem to cloud, then for transforming HDFS Ranger service policies to Cloud policies &lt;b&gt;NO resource mapping is needed&lt;/b&gt;. Instead, provide one of the following: #getHdfsToAdlsArgs(), #getHdfsToS3Args(), #getHdfsToGcsArgs() &lt;p&gt; &lt;b&gt;HIVE prefixed based resource URL replacement is supported&lt;/b&gt;, but it should be provided in a &lt;b&gt;different mapping&lt;/b&gt;, for more info see #getHiveUrlsMapping(). |  [optional]
**hiveUrlsMapping** | **Map&lt;String, String&gt;** | Used for &lt;b&gt;HIVE prefixed based resource URL replacement&lt;/b&gt;. &lt;p&gt; &lt;b&gt;For instance&lt;/b&gt;, if Hive resource URLs on &lt;b&gt;source&lt;/b&gt; are: &lt;ul&gt; &lt;li&gt;hdfs://namenodehost:8020/user/hive/warehouse/table1&lt;/li&gt; &lt;li&gt;hdfs://namenodehost:8020/user/hive/warehouse/table2&lt;/li&gt; &lt;/ul&gt; and &lt;b&gt;destination is Amazon S3&lt;/b&gt;, and the resource mapping contains the following entry: &lt;br&gt; \&quot;hdfs://namenodehost:8020/user/hive/warehouse\&quot;: \&quot;s3a://bucket\&quot; &lt;br&gt; then after transformation hive urls will be: &lt;ul&gt; &lt;li&gt;s3a://bucket/table1&lt;/li&gt; &lt;li&gt;s3a://bucket/table2&lt;/li&gt; &lt;/ul&gt; Default: empty or null, every HIVE URL will remain the same on destination. |  [optional]
**hdfsToAdlsArgs** | [**ApiRangerReplicationHdfsToAdlsArgs**](ApiRangerReplicationHdfsToAdlsArgs.md) |  |  [optional]
**hdfsToS3Args** | [**ApiRangerReplicationHdfsToS3Args**](ApiRangerReplicationHdfsToS3Args.md) |  |  [optional]
**hdfsToGcsArgs** | [**ApiRangerReplicationHdfsToGcsArgs**](ApiRangerReplicationHdfsToGcsArgs.md) |  |  [optional]
