/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v57</h1>       <p>Introduced in Cloudera Manager 7.13.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 7.13.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package com.cloudera.api.swagger.model;

import java.util.Objects;
import java.util.Arrays;
import com.cloudera.api.swagger.model.ApiHostCertInfo;
import com.cloudera.api.swagger.model.BaseApiSshCmdArguments;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
/**
 * Arguments to generate a Cloudera Manager Certificate Authority (CMCA).
 */
@Schema(description = "Arguments to generate a Cloudera Manager Certificate Authority (CMCA).")
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2024-12-03T06:12:24.176Z[Etc/UTC]")

public class ApiGenerateCmcaArguments extends BaseApiSshCmdArguments {
  @SerializedName("location")
  private String location = null;

  @SerializedName("customCA")
  private Boolean customCA = null;

  @SerializedName("interpretAsFilenames")
  private Boolean interpretAsFilenames = null;

  @SerializedName("cmHostCert")
  private String cmHostCert = null;

  @SerializedName("cmHostKey")
  private String cmHostKey = null;

  @SerializedName("caCert")
  private String caCert = null;

  @SerializedName("keystorePasswd")
  private String keystorePasswd = null;

  @SerializedName("truststorePasswd")
  private String truststorePasswd = null;

  @SerializedName("trustedCaCerts")
  private String trustedCaCerts = null;

  @SerializedName("additionalArguments")
  private List<String> additionalArguments = null;

  @SerializedName("hostCerts")
  private List<ApiHostCertInfo> hostCerts = null;

  @SerializedName("configureAllServices")
  private Boolean configureAllServices = null;

  public ApiGenerateCmcaArguments location(String location) {
    this.location = location;
    return this;
  }

   /**
   * The location on disk to store the CMCA directory. If there is already a CMCA created there, it will be backed up, and a new one will be created in its place.
   * @return location
  **/
  @Schema(example = "/opt/cloudera/CMCA", description = "The location on disk to store the CMCA directory. If there is already a CMCA created there, it will be backed up, and a new one will be created in its place.")
  public String getLocation() {
    return location;
  }

  public void setLocation(String location) {
    this.location = location;
  }

  public ApiGenerateCmcaArguments customCA(Boolean customCA) {
    this.customCA = customCA;
    return this;
  }

   /**
   * Whether to generate an internal CMCA (false) or use user-provided certificates (true).  When set to true (user-provided certificates), the following other arguments must be given: * cmHostCert * cmHostKey * caCert * keystorePasswd * truststorePasswd
   * @return customCA
  **/
  @Schema(example = "false", description = "Whether to generate an internal CMCA (false) or use user-provided certificates (true).  When set to true (user-provided certificates), the following other arguments must be given: * cmHostCert * cmHostKey * caCert * keystorePasswd * truststorePasswd")
  public Boolean isCustomCA() {
    return customCA;
  }

  public void setCustomCA(Boolean customCA) {
    this.customCA = customCA;
  }

  public ApiGenerateCmcaArguments interpretAsFilenames(Boolean interpretAsFilenames) {
    this.interpretAsFilenames = interpretAsFilenames;
    return this;
  }

   /**
   * Whether the following arguments are interpreted as filenames local to the Cloudera Manager host (true, default) or as the actual data for that argument: * cmHostCert * cmHostKey * caCert * keystorePasswd * truststorePasswd * trustedCaCerts * hostCerts.hostCert * hostCerts.hostKey  If HTTPS has not been enabled on the Cloudera Manager Admin Console and API, we *strongly* recommend that you pass the arguments as filenames local to the Cloudera Manager host (i.e. set to true) to avoid leaking sensitive information over the wire in plaintext.
   * @return interpretAsFilenames
  **/
  @Schema(example = "true", description = "Whether the following arguments are interpreted as filenames local to the Cloudera Manager host (true, default) or as the actual data for that argument: * cmHostCert * cmHostKey * caCert * keystorePasswd * truststorePasswd * trustedCaCerts * hostCerts.hostCert * hostCerts.hostKey  If HTTPS has not been enabled on the Cloudera Manager Admin Console and API, we *strongly* recommend that you pass the arguments as filenames local to the Cloudera Manager host (i.e. set to true) to avoid leaking sensitive information over the wire in plaintext.")
  public Boolean isInterpretAsFilenames() {
    return interpretAsFilenames;
  }

  public void setInterpretAsFilenames(Boolean interpretAsFilenames) {
    this.interpretAsFilenames = interpretAsFilenames;
  }

  public ApiGenerateCmcaArguments cmHostCert(String cmHostCert) {
    this.cmHostCert = cmHostCert;
    return this;
  }

   /**
   * The certificate for the CM host in PEM format. Only used if customCA &#x3D;&#x3D; true.
   * @return cmHostCert
  **/
  @Schema(example = "host-cert.pem", description = "The certificate for the CM host in PEM format. Only used if customCA == true.")
  public String getCmHostCert() {
    return cmHostCert;
  }

  public void setCmHostCert(String cmHostCert) {
    this.cmHostCert = cmHostCert;
  }

  public ApiGenerateCmcaArguments cmHostKey(String cmHostKey) {
    this.cmHostKey = cmHostKey;
    return this;
  }

   /**
   * The private key for the CM host in PEM format. Only used if customCA &#x3D;&#x3D; true.
   * @return cmHostKey
  **/
  @Schema(example = "host-key.pem", description = "The private key for the CM host in PEM format. Only used if customCA == true.")
  public String getCmHostKey() {
    return cmHostKey;
  }

  public void setCmHostKey(String cmHostKey) {
    this.cmHostKey = cmHostKey;
  }

  public ApiGenerateCmcaArguments caCert(String caCert) {
    this.caCert = caCert;
    return this;
  }

   /**
   * The certificate for the user-provided certificate authority in PEM format. Only used if customCA &#x3D;&#x3D; true.
   * @return caCert
  **/
  @Schema(example = "ca-cert.pem", description = "The certificate for the user-provided certificate authority in PEM format. Only used if customCA == true.")
  public String getCaCert() {
    return caCert;
  }

  public void setCaCert(String caCert) {
    this.caCert = caCert;
  }

  public ApiGenerateCmcaArguments keystorePasswd(String keystorePasswd) {
    this.keystorePasswd = keystorePasswd;
    return this;
  }

   /**
   * The password used for all Auto-TLS keystores. Only used if customCA &#x3D;&#x3D; true.
   * @return keystorePasswd
  **/
  @Schema(example = "keystore.pw.txt", description = "The password used for all Auto-TLS keystores. Only used if customCA == true.")
  public String getKeystorePasswd() {
    return keystorePasswd;
  }

  public void setKeystorePasswd(String keystorePasswd) {
    this.keystorePasswd = keystorePasswd;
  }

  public ApiGenerateCmcaArguments truststorePasswd(String truststorePasswd) {
    this.truststorePasswd = truststorePasswd;
    return this;
  }

   /**
   * The password used for all Auto-TLS truststores. Only used if customCA &#x3D;&#x3D; true.
   * @return truststorePasswd
  **/
  @Schema(example = "truststore.pw.txt", description = "The password used for all Auto-TLS truststores. Only used if customCA == true.")
  public String getTruststorePasswd() {
    return truststorePasswd;
  }

  public void setTruststorePasswd(String truststorePasswd) {
    this.truststorePasswd = truststorePasswd;
  }

  public ApiGenerateCmcaArguments trustedCaCerts(String trustedCaCerts) {
    this.trustedCaCerts = trustedCaCerts;
    return this;
  }

   /**
   * A list of CA certificates that will be imported into the Auto-TLS truststore and distributed to all hosts.
   * @return trustedCaCerts
  **/
  @Schema(example = "cacerts.pem", description = "A list of CA certificates that will be imported into the Auto-TLS truststore and distributed to all hosts.")
  public String getTrustedCaCerts() {
    return trustedCaCerts;
  }

  public void setTrustedCaCerts(String trustedCaCerts) {
    this.trustedCaCerts = trustedCaCerts;
  }

  public ApiGenerateCmcaArguments additionalArguments(List<String> additionalArguments) {
    this.additionalArguments = additionalArguments;
    return this;
  }

  public ApiGenerateCmcaArguments addAdditionalArgumentsItem(String additionalArgumentsItem) {
    if (this.additionalArguments == null) {
      this.additionalArguments = new ArrayList<>();
    }
    this.additionalArguments.add(additionalArgumentsItem);
    return this;
  }

   /**
   * A list of additional arguments that can be passed to the certificate manager
   * @return additionalArguments
  **/
  @Schema(example = "--override", description = "A list of additional arguments that can be passed to the certificate manager")
  public List<String> getAdditionalArguments() {
    return additionalArguments;
  }

  public void setAdditionalArguments(List<String> additionalArguments) {
    this.additionalArguments = additionalArguments;
  }

  public ApiGenerateCmcaArguments hostCerts(List<ApiHostCertInfo> hostCerts) {
    this.hostCerts = hostCerts;
    return this;
  }

  public ApiGenerateCmcaArguments addHostCertsItem(ApiHostCertInfo hostCertsItem) {
    if (this.hostCerts == null) {
      this.hostCerts = new ArrayList<>();
    }
    this.hostCerts.add(hostCertsItem);
    return this;
  }

   /**
   * A list of HostCertInfo objects, which associate a hostname with the corresponding certificate and private key. Only used if customCA &#x3D;&#x3D; true.
   * @return hostCerts
  **/
  @Schema(description = "A list of HostCertInfo objects, which associate a hostname with the corresponding certificate and private key. Only used if customCA == true.")
  public List<ApiHostCertInfo> getHostCerts() {
    return hostCerts;
  }

  public void setHostCerts(List<ApiHostCertInfo> hostCerts) {
    this.hostCerts = hostCerts;
  }

  public ApiGenerateCmcaArguments configureAllServices(Boolean configureAllServices) {
    this.configureAllServices = configureAllServices;
    return this;
  }

   /**
   * Whether to configure all existing services to use Auto-TLS. Defaults to false.  If false, only MGMT services will be configured to use Auto-TLS. Use the cluster-level ConfigureAutoTlsServices command to configure Auto-TLS services for a single cluster only.  All future services will be configured to use Auto-TLS regardless of this setting.
   * @return configureAllServices
  **/
  @Schema(description = "Whether to configure all existing services to use Auto-TLS. Defaults to false.  If false, only MGMT services will be configured to use Auto-TLS. Use the cluster-level ConfigureAutoTlsServices command to configure Auto-TLS services for a single cluster only.  All future services will be configured to use Auto-TLS regardless of this setting.")
  public Boolean isConfigureAllServices() {
    return configureAllServices;
  }

  public void setConfigureAllServices(Boolean configureAllServices) {
    this.configureAllServices = configureAllServices;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiGenerateCmcaArguments apiGenerateCmcaArguments = (ApiGenerateCmcaArguments) o;
    return Objects.equals(this.location, apiGenerateCmcaArguments.location) &&
        Objects.equals(this.customCA, apiGenerateCmcaArguments.customCA) &&
        Objects.equals(this.interpretAsFilenames, apiGenerateCmcaArguments.interpretAsFilenames) &&
        Objects.equals(this.cmHostCert, apiGenerateCmcaArguments.cmHostCert) &&
        Objects.equals(this.cmHostKey, apiGenerateCmcaArguments.cmHostKey) &&
        Objects.equals(this.caCert, apiGenerateCmcaArguments.caCert) &&
        Objects.equals(this.keystorePasswd, apiGenerateCmcaArguments.keystorePasswd) &&
        Objects.equals(this.truststorePasswd, apiGenerateCmcaArguments.truststorePasswd) &&
        Objects.equals(this.trustedCaCerts, apiGenerateCmcaArguments.trustedCaCerts) &&
        Objects.equals(this.additionalArguments, apiGenerateCmcaArguments.additionalArguments) &&
        Objects.equals(this.hostCerts, apiGenerateCmcaArguments.hostCerts) &&
        Objects.equals(this.configureAllServices, apiGenerateCmcaArguments.configureAllServices) &&
        super.equals(o);
  }

  @Override
  public int hashCode() {
    return Objects.hash(location, customCA, interpretAsFilenames, cmHostCert, cmHostKey, caCert, keystorePasswd, truststorePasswd, trustedCaCerts, additionalArguments, hostCerts, configureAllServices, super.hashCode());
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiGenerateCmcaArguments {\n");
    sb.append("    ").append(toIndentedString(super.toString())).append("\n");
    sb.append("    location: ").append(toIndentedString(location)).append("\n");
    sb.append("    customCA: ").append(toIndentedString(customCA)).append("\n");
    sb.append("    interpretAsFilenames: ").append(toIndentedString(interpretAsFilenames)).append("\n");
    sb.append("    cmHostCert: ").append(toIndentedString(cmHostCert)).append("\n");
    sb.append("    cmHostKey: ").append(toIndentedString(cmHostKey)).append("\n");
    sb.append("    caCert: ").append(toIndentedString(caCert)).append("\n");
    sb.append("    keystorePasswd: ").append(toIndentedString(keystorePasswd)).append("\n");
    sb.append("    truststorePasswd: ").append(toIndentedString(truststorePasswd)).append("\n");
    sb.append("    trustedCaCerts: ").append(toIndentedString(trustedCaCerts)).append("\n");
    sb.append("    additionalArguments: ").append(toIndentedString(additionalArguments)).append("\n");
    sb.append("    hostCerts: ").append(toIndentedString(hostCerts)).append("\n");
    sb.append("    configureAllServices: ").append(toIndentedString(configureAllServices)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
