/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v57</h1>       <p>Introduced in Cloudera Manager 7.13.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 7.13.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package com.cloudera.api.swagger.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
/**
 * Encapsulates information needed to utilize the s3 Gateway API- namely, the AWS credentials, the rest url of the s3 Gateway and the S3 bucket.
 */
@Schema(description = "Encapsulates information needed to utilize the s3 Gateway API- namely, the AWS credentials, the rest url of the s3 Gateway and the S3 bucket.")
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2024-12-03T06:12:24.176Z[Etc/UTC]")

public class ApiOzoneS3GatewayInfo {
  @SerializedName("awsAccessKey")
  private String awsAccessKey = null;

  @SerializedName("awsSecret")
  private String awsSecret = null;

  @SerializedName("restUrl")
  private String restUrl = null;

  @SerializedName("restUrls")
  private List<String> restUrls = null;

  @SerializedName("bucket")
  private String bucket = null;

  public ApiOzoneS3GatewayInfo awsAccessKey(String awsAccessKey) {
    this.awsAccessKey = awsAccessKey;
    return this;
  }

   /**
   * The AWS access key for a particular Ozone service
   * @return awsAccessKey
  **/
  @Schema(description = "The AWS access key for a particular Ozone service")
  public String getAwsAccessKey() {
    return awsAccessKey;
  }

  public void setAwsAccessKey(String awsAccessKey) {
    this.awsAccessKey = awsAccessKey;
  }

  public ApiOzoneS3GatewayInfo awsSecret(String awsSecret) {
    this.awsSecret = awsSecret;
    return this;
  }

   /**
   * The AWS secret associated with the access key
   * @return awsSecret
  **/
  @Schema(description = "The AWS secret associated with the access key")
  public String getAwsSecret() {
    return awsSecret;
  }

  public void setAwsSecret(String awsSecret) {
    this.awsSecret = awsSecret;
  }

  public ApiOzoneS3GatewayInfo restUrl(String restUrl) {
    this.restUrl = restUrl;
    return this;
  }

   /**
   * The rest url, in host:port format, of the Ozone S3 Gateway. Always returns the first entry in the list of rest urls or null if list is null or zero-length.
   * @return restUrl
  **/
  @Schema(description = "The rest url, in host:port format, of the Ozone S3 Gateway. Always returns the first entry in the list of rest urls or null if list is null or zero-length.")
  public String getRestUrl() {
    return restUrl;
  }

  public void setRestUrl(String restUrl) {
    this.restUrl = restUrl;
  }

  public ApiOzoneS3GatewayInfo restUrls(List<String> restUrls) {
    this.restUrls = restUrls;
    return this;
  }

  public ApiOzoneS3GatewayInfo addRestUrlsItem(String restUrlsItem) {
    if (this.restUrls == null) {
      this.restUrls = new ArrayList<>();
    }
    this.restUrls.add(restUrlsItem);
    return this;
  }

   /**
   * The list of rest urls, in host:port format, of the Ozone S3 Gateway
   * @return restUrls
  **/
  @Schema(description = "The list of rest urls, in host:port format, of the Ozone S3 Gateway")
  public List<String> getRestUrls() {
    return restUrls;
  }

  public void setRestUrls(List<String> restUrls) {
    this.restUrls = restUrls;
  }

  public ApiOzoneS3GatewayInfo bucket(String bucket) {
    this.bucket = bucket;
    return this;
  }

   /**
   * The Ozone address of the created S3 bucket
   * @return bucket
  **/
  @Schema(description = "The Ozone address of the created S3 bucket")
  public String getBucket() {
    return bucket;
  }

  public void setBucket(String bucket) {
    this.bucket = bucket;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiOzoneS3GatewayInfo apiOzoneS3GatewayInfo = (ApiOzoneS3GatewayInfo) o;
    return Objects.equals(this.awsAccessKey, apiOzoneS3GatewayInfo.awsAccessKey) &&
        Objects.equals(this.awsSecret, apiOzoneS3GatewayInfo.awsSecret) &&
        Objects.equals(this.restUrl, apiOzoneS3GatewayInfo.restUrl) &&
        Objects.equals(this.restUrls, apiOzoneS3GatewayInfo.restUrls) &&
        Objects.equals(this.bucket, apiOzoneS3GatewayInfo.bucket);
  }

  @Override
  public int hashCode() {
    return Objects.hash(awsAccessKey, awsSecret, restUrl, restUrls, bucket);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiOzoneS3GatewayInfo {\n");
    
    sb.append("    awsAccessKey: ").append(toIndentedString(awsAccessKey)).append("\n");
    sb.append("    awsSecret: ").append(toIndentedString(awsSecret)).append("\n");
    sb.append("    restUrl: ").append(toIndentedString(restUrl)).append("\n");
    sb.append("    restUrls: ").append(toIndentedString(restUrls)).append("\n");
    sb.append("    bucket: ").append(toIndentedString(bucket)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
