/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v57</h1>       <p>Introduced in Cloudera Manager 7.13.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 7.13.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package com.cloudera.api.swagger.model;

import java.util.Objects;
import java.util.Arrays;
import com.cloudera.api.swagger.model.ApiClusterRef;
import com.cloudera.api.swagger.model.ApiCommand;
import com.cloudera.api.swagger.model.ApiCommandList;
import com.cloudera.api.swagger.model.ApiHBaseSnapshotResult;
import com.cloudera.api.swagger.model.ApiHdfsSnapshotResult;
import com.cloudera.api.swagger.model.ApiHostRef;
import com.cloudera.api.swagger.model.ApiOzoneSnapshotResult;
import com.cloudera.api.swagger.model.ApiRoleRef;
import com.cloudera.api.swagger.model.ApiServiceRef;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
/**
 * Information about snapshot commands. &lt;p/&gt; This object holds all the information a regular ApiCommand object provides, and adds specific information about the results of a snapshot command. &lt;p/&gt; Depending on the type of the service where the snapshot command was run, a different result property will be populated.
 */
@Schema(description = "Information about snapshot commands. <p/> This object holds all the information a regular ApiCommand object provides, and adds specific information about the results of a snapshot command. <p/> Depending on the type of the service where the snapshot command was run, a different result property will be populated.")
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2024-12-03T06:12:24.176Z[Etc/UTC]")

public class ApiSnapshotCommand extends ApiCommand {
  @SerializedName("hbaseResult")
  private ApiHBaseSnapshotResult hbaseResult = null;

  @SerializedName("hdfsResult")
  private ApiHdfsSnapshotResult hdfsResult = null;

  @SerializedName("ozoneResult")
  private ApiOzoneSnapshotResult ozoneResult = null;

  public ApiSnapshotCommand hbaseResult(ApiHBaseSnapshotResult hbaseResult) {
    this.hbaseResult = hbaseResult;
    return this;
  }

   /**
   * Get hbaseResult
   * @return hbaseResult
  **/
  @Schema(description = "")
  public ApiHBaseSnapshotResult getHbaseResult() {
    return hbaseResult;
  }

  public void setHbaseResult(ApiHBaseSnapshotResult hbaseResult) {
    this.hbaseResult = hbaseResult;
  }

  public ApiSnapshotCommand hdfsResult(ApiHdfsSnapshotResult hdfsResult) {
    this.hdfsResult = hdfsResult;
    return this;
  }

   /**
   * Get hdfsResult
   * @return hdfsResult
  **/
  @Schema(description = "")
  public ApiHdfsSnapshotResult getHdfsResult() {
    return hdfsResult;
  }

  public void setHdfsResult(ApiHdfsSnapshotResult hdfsResult) {
    this.hdfsResult = hdfsResult;
  }

  public ApiSnapshotCommand ozoneResult(ApiOzoneSnapshotResult ozoneResult) {
    this.ozoneResult = ozoneResult;
    return this;
  }

   /**
   * Get ozoneResult
   * @return ozoneResult
  **/
  @Schema(description = "")
  public ApiOzoneSnapshotResult getOzoneResult() {
    return ozoneResult;
  }

  public void setOzoneResult(ApiOzoneSnapshotResult ozoneResult) {
    this.ozoneResult = ozoneResult;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiSnapshotCommand apiSnapshotCommand = (ApiSnapshotCommand) o;
    return Objects.equals(this.hbaseResult, apiSnapshotCommand.hbaseResult) &&
        Objects.equals(this.hdfsResult, apiSnapshotCommand.hdfsResult) &&
        Objects.equals(this.ozoneResult, apiSnapshotCommand.ozoneResult) &&
        super.equals(o);
  }

  @Override
  public int hashCode() {
    return Objects.hash(hbaseResult, hdfsResult, ozoneResult, super.hashCode());
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiSnapshotCommand {\n");
    sb.append("    ").append(toIndentedString(super.toString())).append("\n");
    sb.append("    hbaseResult: ").append(toIndentedString(hbaseResult)).append("\n");
    sb.append("    hdfsResult: ").append(toIndentedString(hdfsResult)).append("\n");
    sb.append("    ozoneResult: ").append(toIndentedString(ozoneResult)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
