# coding: utf-8

"""
    Cloudera Manager API

    <h1>Cloudera Manager API v57</h1>       <p>Introduced in Cloudera Manager 7.13.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>  # noqa: E501

    OpenAPI spec version: 7.13.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from cm_client.api_client import ApiClient


class ControlPlanesResourceApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def add_tags(self, control_plane_uuid, **kwargs):  # noqa: E501
        """Attach tags to the control plane.  # noqa: E501

        Attach tags to the control plane.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_tags(control_plane_uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str control_plane_uuid: The uuid of the control plane. (required)
        :param list[ApiEntityTag] body: List of tags to add to the control plane
        :return: list[ApiEntityTag]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.add_tags_with_http_info(control_plane_uuid, **kwargs)  # noqa: E501
        else:
            (data) = self.add_tags_with_http_info(control_plane_uuid, **kwargs)  # noqa: E501
            return data

    def add_tags_with_http_info(self, control_plane_uuid, **kwargs):  # noqa: E501
        """Attach tags to the control plane.  # noqa: E501

        Attach tags to the control plane.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_tags_with_http_info(control_plane_uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str control_plane_uuid: The uuid of the control plane. (required)
        :param list[ApiEntityTag] body: List of tags to add to the control plane
        :return: list[ApiEntityTag]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['control_plane_uuid', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_tags" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'control_plane_uuid' is set
        if ('control_plane_uuid' not in params or
                params['control_plane_uuid'] is None):
            raise ValueError("Missing the required parameter `control_plane_uuid` when calling `add_tags`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'control_plane_uuid' in params:
            path_params['controlPlaneUuid'] = params['control_plane_uuid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/controlPlanes/{controlPlaneUuid}/tags', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[ApiEntityTag]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def copy_images_in_features(self, control_plane_uuid, **kwargs):  # noqa: E501
        """Launches the command to copy images for one or more features (a comma separated list).  # noqa: E501

        Launches the command to copy images for one or more features (a comma separated list).  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.copy_images_in_features(control_plane_uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str control_plane_uuid: (required)
        :param ApiCopyImagesInFeaturesArgs body: Arguments for the Command
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.copy_images_in_features_with_http_info(control_plane_uuid, **kwargs)  # noqa: E501
        else:
            (data) = self.copy_images_in_features_with_http_info(control_plane_uuid, **kwargs)  # noqa: E501
            return data

    def copy_images_in_features_with_http_info(self, control_plane_uuid, **kwargs):  # noqa: E501
        """Launches the command to copy images for one or more features (a comma separated list).  # noqa: E501

        Launches the command to copy images for one or more features (a comma separated list).  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.copy_images_in_features_with_http_info(control_plane_uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str control_plane_uuid: (required)
        :param ApiCopyImagesInFeaturesArgs body: Arguments for the Command
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['control_plane_uuid', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method copy_images_in_features" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'control_plane_uuid' is set
        if ('control_plane_uuid' not in params or
                params['control_plane_uuid'] is None):
            raise ValueError("Missing the required parameter `control_plane_uuid` when calling `copy_images_in_features`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'control_plane_uuid' in params:
            path_params['controlPlaneUuid'] = params['control_plane_uuid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/controlPlanes/{controlPlaneUuid}/commands/copyImagesInFeatures', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiCommand',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_tags(self, control_plane_uuid, **kwargs):  # noqa: E501
        """Remove the tags associated with the control plane.  # noqa: E501

        Remove the tags associated with the control plane  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_tags(control_plane_uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str control_plane_uuid: The uuid of the control plane. (required)
        :param list[ApiEntityTag] body: A list of tags to remove from the control plane
        :return: list[ApiEntityTag]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_tags_with_http_info(control_plane_uuid, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_tags_with_http_info(control_plane_uuid, **kwargs)  # noqa: E501
            return data

    def delete_tags_with_http_info(self, control_plane_uuid, **kwargs):  # noqa: E501
        """Remove the tags associated with the control plane.  # noqa: E501

        Remove the tags associated with the control plane  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_tags_with_http_info(control_plane_uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str control_plane_uuid: The uuid of the control plane. (required)
        :param list[ApiEntityTag] body: A list of tags to remove from the control plane
        :return: list[ApiEntityTag]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['control_plane_uuid', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_tags" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'control_plane_uuid' is set
        if ('control_plane_uuid' not in params or
                params['control_plane_uuid'] is None):
            raise ValueError("Missing the required parameter `control_plane_uuid` when calling `delete_tags`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'control_plane_uuid' in params:
            path_params['controlPlaneUuid'] = params['control_plane_uuid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/controlPlanes/{controlPlaneUuid}/tags', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[ApiEntityTag]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def generate_copy_docker(self, **kwargs):  # noqa: E501
        """Launches the Generate Copy Docker Script Command.  # noqa: E501

        Launches the Generate Copy Docker Script Command  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.generate_copy_docker(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ApiGenerateCopyDockerArgs body: Arguments for the Command
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.generate_copy_docker_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.generate_copy_docker_with_http_info(**kwargs)  # noqa: E501
            return data

    def generate_copy_docker_with_http_info(self, **kwargs):  # noqa: E501
        """Launches the Generate Copy Docker Script Command.  # noqa: E501

        Launches the Generate Copy Docker Script Command  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.generate_copy_docker_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ApiGenerateCopyDockerArgs body: Arguments for the Command
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method generate_copy_docker" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/controlPlanes/commands/generateCopyDocker', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiCommand',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def generate_external_vault_setup(self, **kwargs):  # noqa: E501
        """Launches the Generate Vault Setup Command command.  # noqa: E501

        Launches the Generate Vault Setup Command command  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.generate_external_vault_setup(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ApiGenerateExternalVaultSetupArgs body: Arguments for the Command
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.generate_external_vault_setup_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.generate_external_vault_setup_with_http_info(**kwargs)  # noqa: E501
            return data

    def generate_external_vault_setup_with_http_info(self, **kwargs):  # noqa: E501
        """Launches the Generate Vault Setup Command command.  # noqa: E501

        Launches the Generate Vault Setup Command command  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.generate_external_vault_setup_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ApiGenerateExternalVaultSetupArgs body: Arguments for the Command
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method generate_external_vault_setup" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/controlPlanes/commands/generateExternalVaultSetup', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiCommand',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_control_planes(self, **kwargs):  # noqa: E501
        """Current Control Planes.  # noqa: E501

        Current Control Planes  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_control_planes(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: ApiControlPlaneList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_control_planes_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_control_planes_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_control_planes_with_http_info(self, **kwargs):  # noqa: E501
        """Current Control Planes.  # noqa: E501

        Current Control Planes  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_control_planes_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: ApiControlPlaneList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_control_planes" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/controlPlanes', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiControlPlaneList',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_experience_cluster(self, control_plane_uuid, **kwargs):  # noqa: E501
        """The cluster with tags matching this control plane's UUID, if any.  # noqa: E501

        The cluster with tags matching this control plane's UUID, if any  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_experience_cluster(control_plane_uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str control_plane_uuid: The universally unique id of the control plane (required)
        :return: ApiCluster
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_experience_cluster_with_http_info(control_plane_uuid, **kwargs)  # noqa: E501
        else:
            (data) = self.get_experience_cluster_with_http_info(control_plane_uuid, **kwargs)  # noqa: E501
            return data

    def get_experience_cluster_with_http_info(self, control_plane_uuid, **kwargs):  # noqa: E501
        """The cluster with tags matching this control plane's UUID, if any.  # noqa: E501

        The cluster with tags matching this control plane's UUID, if any  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_experience_cluster_with_http_info(control_plane_uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str control_plane_uuid: The universally unique id of the control plane (required)
        :return: ApiCluster
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['control_plane_uuid']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_experience_cluster" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'control_plane_uuid' is set
        if ('control_plane_uuid' not in params or
                params['control_plane_uuid'] is None):
            raise ValueError("Missing the required parameter `control_plane_uuid` when calling `get_experience_cluster`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'control_plane_uuid' in params:
            path_params['controlPlaneUuid'] = params['control_plane_uuid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/controlPlanes/{controlPlaneUuid}/getTaggedCluster', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiCluster',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_log_content(self, command_id, **kwargs):  # noqa: E501
        """Fetches the log content for the specific command.  # noqa: E501

        Fetches the log content for the specific command.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_log_content(command_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int command_id: the command id (required)
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_log_content_with_http_info(command_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_log_content_with_http_info(command_id, **kwargs)  # noqa: E501
            return data

    def get_log_content_with_http_info(self, command_id, **kwargs):  # noqa: E501
        """Fetches the log content for the specific command.  # noqa: E501

        Fetches the log content for the specific command.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_log_content_with_http_info(command_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int command_id: the command id (required)
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['command_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_log_content" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'command_id' is set
        if ('command_id' not in params or
                params['command_id'] is None):
            raise ValueError("Missing the required parameter `command_id` when calling `get_log_content`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'command_id' in params:
            path_params['commandId'] = params['command_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/controlPlanes/fetchResources/{commandId}/logContent', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='str',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_manifest_json(self, **kwargs):  # noqa: E501
        """Fetches the manifest.  # noqa: E501

        Fetches the manifest.json under the specified remote repo.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_manifest_json(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ApiRemoteRepoUrl body: the remote repo url.
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_manifest_json_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_manifest_json_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_manifest_json_with_http_info(self, **kwargs):  # noqa: E501
        """Fetches the manifest.  # noqa: E501

        Fetches the manifest.json under the specified remote repo.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_manifest_json_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ApiRemoteRepoUrl body: the remote repo url.
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_manifest_json" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/controlPlanes/fetchResources/manifest.json', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='str',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def install_control_plane(self, **kwargs):  # noqa: E501
        """Launches the install control plane command.  # noqa: E501

        Launches the install control plane command.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.install_control_plane(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ApiInstallControlPlaneArgs body: Arguments for the Command
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.install_control_plane_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.install_control_plane_with_http_info(**kwargs)  # noqa: E501
            return data

    def install_control_plane_with_http_info(self, **kwargs):  # noqa: E501
        """Launches the install control plane command.  # noqa: E501

        Launches the install control plane command.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.install_control_plane_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ApiInstallControlPlaneArgs body: Arguments for the Command
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method install_control_plane" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/controlPlanes/commands/installControlPlane', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiCommand',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def install_embedded_control_plane(self, **kwargs):  # noqa: E501
        """Brings up a control plane on embedded kubernetes.  # noqa: E501

        Brings up a control plane on embedded kubernetes. At its core, this command launches the FirstRun command on the Containerized Cluster.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.install_embedded_control_plane(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ApiInstallEmbeddedControlPlaneArgs body: The arguments for Ek8s control plane installation
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.install_embedded_control_plane_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.install_embedded_control_plane_with_http_info(**kwargs)  # noqa: E501
            return data

    def install_embedded_control_plane_with_http_info(self, **kwargs):  # noqa: E501
        """Brings up a control plane on embedded kubernetes.  # noqa: E501

        Brings up a control plane on embedded kubernetes. At its core, this command launches the FirstRun command on the Containerized Cluster.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.install_embedded_control_plane_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ApiInstallEmbeddedControlPlaneArgs body: The arguments for Ek8s control plane installation
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method install_embedded_control_plane" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/controlPlanes/commands/installEmbeddedControlPlane', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiCommand',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def read_control_plane_by_uuid(self, control_plane_uuid, **kwargs):  # noqa: E501
        """The control plane with the given id.  # noqa: E501

        The control plane with the given id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.read_control_plane_by_uuid(control_plane_uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str control_plane_uuid: The universally unique id of the control plane (required)
        :return: ApiControlPlane
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.read_control_plane_by_uuid_with_http_info(control_plane_uuid, **kwargs)  # noqa: E501
        else:
            (data) = self.read_control_plane_by_uuid_with_http_info(control_plane_uuid, **kwargs)  # noqa: E501
            return data

    def read_control_plane_by_uuid_with_http_info(self, control_plane_uuid, **kwargs):  # noqa: E501
        """The control plane with the given id.  # noqa: E501

        The control plane with the given id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.read_control_plane_by_uuid_with_http_info(control_plane_uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str control_plane_uuid: The universally unique id of the control plane (required)
        :return: ApiControlPlane
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['control_plane_uuid']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method read_control_plane_by_uuid" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'control_plane_uuid' is set
        if ('control_plane_uuid' not in params or
                params['control_plane_uuid'] is None):
            raise ValueError("Missing the required parameter `control_plane_uuid` when calling `read_control_plane_by_uuid`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'control_plane_uuid' in params:
            path_params['controlPlaneUuid'] = params['control_plane_uuid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/controlPlanes/{controlPlaneUuid}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiControlPlane',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def read_tags(self, control_plane_uuid, **kwargs):  # noqa: E501
        """Returns the tags associated with this control plane.  # noqa: E501

        Returns the tags associated with this control plane.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.read_tags(control_plane_uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str control_plane_uuid: The uuid of the control plane. (required)
        :param int limit: Number of tags
        :param int offset: Index of the first tag to retrieve
        :return: list[ApiEntityTag]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.read_tags_with_http_info(control_plane_uuid, **kwargs)  # noqa: E501
        else:
            (data) = self.read_tags_with_http_info(control_plane_uuid, **kwargs)  # noqa: E501
            return data

    def read_tags_with_http_info(self, control_plane_uuid, **kwargs):  # noqa: E501
        """Returns the tags associated with this control plane.  # noqa: E501

        Returns the tags associated with this control plane.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.read_tags_with_http_info(control_plane_uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str control_plane_uuid: The uuid of the control plane. (required)
        :param int limit: Number of tags
        :param int offset: Index of the first tag to retrieve
        :return: list[ApiEntityTag]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['control_plane_uuid', 'limit', 'offset']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method read_tags" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'control_plane_uuid' is set
        if ('control_plane_uuid' not in params or
                params['control_plane_uuid'] is None):
            raise ValueError("Missing the required parameter `control_plane_uuid` when calling `read_tags`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'control_plane_uuid' in params:
            path_params['controlPlaneUuid'] = params['control_plane_uuid']  # noqa: E501

        query_params = []
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501
        if 'offset' in params:
            query_params.append(('offset', params['offset']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/controlPlanes/{controlPlaneUuid}/tags', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[ApiEntityTag]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def uninstall_control_plane(self, control_plane_uuid, **kwargs):  # noqa: E501
        """Launches Uninstall Command on the control plane with the given uuid.  # noqa: E501

        Launches Uninstall Command on the control plane with the given uuid  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.uninstall_control_plane(control_plane_uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str control_plane_uuid: The universally unique id of the control plane (required)
        :param ApiUninstallControlPlaneArgs body: Arguments for the Command
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.uninstall_control_plane_with_http_info(control_plane_uuid, **kwargs)  # noqa: E501
        else:
            (data) = self.uninstall_control_plane_with_http_info(control_plane_uuid, **kwargs)  # noqa: E501
            return data

    def uninstall_control_plane_with_http_info(self, control_plane_uuid, **kwargs):  # noqa: E501
        """Launches Uninstall Command on the control plane with the given uuid.  # noqa: E501

        Launches Uninstall Command on the control plane with the given uuid  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.uninstall_control_plane_with_http_info(control_plane_uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str control_plane_uuid: The universally unique id of the control plane (required)
        :param ApiUninstallControlPlaneArgs body: Arguments for the Command
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['control_plane_uuid', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method uninstall_control_plane" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'control_plane_uuid' is set
        if ('control_plane_uuid' not in params or
                params['control_plane_uuid'] is None):
            raise ValueError("Missing the required parameter `control_plane_uuid` when calling `uninstall_control_plane`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'control_plane_uuid' in params:
            path_params['controlPlaneUuid'] = params['control_plane_uuid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/controlPlanes/{controlPlaneUuid}/commands/uninstallControlPlane', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiCommand',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_values_yaml(self, control_plane_uuid, **kwargs):  # noqa: E501
        """Launches update the values.  # noqa: E501

        Launches update the values.yaml from the control plane with the given uuid This updates the content of values.yaml.merged in the CM database.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_values_yaml(control_plane_uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str control_plane_uuid: The universally unique id of the control plane (required)
        :param ApiUpdateControlPlaneValuesYamlArgs body: Arguments for the Command
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_values_yaml_with_http_info(control_plane_uuid, **kwargs)  # noqa: E501
        else:
            (data) = self.update_values_yaml_with_http_info(control_plane_uuid, **kwargs)  # noqa: E501
            return data

    def update_values_yaml_with_http_info(self, control_plane_uuid, **kwargs):  # noqa: E501
        """Launches update the values.  # noqa: E501

        Launches update the values.yaml from the control plane with the given uuid This updates the content of values.yaml.merged in the CM database.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_values_yaml_with_http_info(control_plane_uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str control_plane_uuid: The universally unique id of the control plane (required)
        :param ApiUpdateControlPlaneValuesYamlArgs body: Arguments for the Command
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['control_plane_uuid', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_values_yaml" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'control_plane_uuid' is set
        if ('control_plane_uuid' not in params or
                params['control_plane_uuid'] is None):
            raise ValueError("Missing the required parameter `control_plane_uuid` when calling `update_values_yaml`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'control_plane_uuid' in params:
            path_params['controlPlaneUuid'] = params['control_plane_uuid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/controlPlanes/{controlPlaneUuid}/commands/updateControlPlaneValuesYaml', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiCommand',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def upgrade_control_plane(self, control_plane_uuid, **kwargs):  # noqa: E501
        """Launches the Upgrade Command on the control plane with the given uuid.  # noqa: E501

        Launches the Upgrade Command on the control plane with the given uuid  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.upgrade_control_plane(control_plane_uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str control_plane_uuid: The universally unique id of the control plane (required)
        :param ApiUpgradeControlPlaneArgs body: Arguments for the Command
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.upgrade_control_plane_with_http_info(control_plane_uuid, **kwargs)  # noqa: E501
        else:
            (data) = self.upgrade_control_plane_with_http_info(control_plane_uuid, **kwargs)  # noqa: E501
            return data

    def upgrade_control_plane_with_http_info(self, control_plane_uuid, **kwargs):  # noqa: E501
        """Launches the Upgrade Command on the control plane with the given uuid.  # noqa: E501

        Launches the Upgrade Command on the control plane with the given uuid  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.upgrade_control_plane_with_http_info(control_plane_uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str control_plane_uuid: The universally unique id of the control plane (required)
        :param ApiUpgradeControlPlaneArgs body: Arguments for the Command
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['control_plane_uuid', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method upgrade_control_plane" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'control_plane_uuid' is set
        if ('control_plane_uuid' not in params or
                params['control_plane_uuid'] is None):
            raise ValueError("Missing the required parameter `control_plane_uuid` when calling `upgrade_control_plane`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'control_plane_uuid' in params:
            path_params['controlPlaneUuid'] = params['control_plane_uuid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/controlPlanes/{controlPlaneUuid}/commands/upgradeControlPlane', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiCommand',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def upgrade_embedded_control_plane(self, **kwargs):  # noqa: E501
        """Upgrade a Containerized Cluster, including upgrading the control plane running on embedded kubernetes.  # noqa: E501

        Upgrade a Containerized Cluster, including upgrading the control plane running on embedded kubernetes.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.upgrade_embedded_control_plane(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ApiUpgradeEmbeddedControlPlaneArgs body: The arguments for Ek8s control plane upgrade
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.upgrade_embedded_control_plane_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.upgrade_embedded_control_plane_with_http_info(**kwargs)  # noqa: E501
            return data

    def upgrade_embedded_control_plane_with_http_info(self, **kwargs):  # noqa: E501
        """Upgrade a Containerized Cluster, including upgrading the control plane running on embedded kubernetes.  # noqa: E501

        Upgrade a Containerized Cluster, including upgrading the control plane running on embedded kubernetes.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.upgrade_embedded_control_plane_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ApiUpgradeEmbeddedControlPlaneArgs body: The arguments for Ek8s control plane upgrade
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method upgrade_embedded_control_plane" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/controlPlanes/commands/upgradeEmbeddedControlPlane', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiCommand',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
