# coding: utf-8

"""
    Cloudera Manager API

    <h1>Cloudera Manager API v57</h1>       <p>Introduced in Cloudera Manager 7.13.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>  # noqa: E501

    OpenAPI spec version: 7.13.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from cm_client.api_client import ApiClient


class HostTemplatesResourceApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def apply_host_template(self, cluster_name, host_template_name, **kwargs):  # noqa: E501
        """Applies a host template to a collection of hosts.  # noqa: E501

        Applies a host template to a collection of hosts. This will create a role for each role config group on each of the hosts. <p> The provided hosts must not have any existing roles on them and if the cluster is not using parcels, the hosts must have a CDH version matching that of the cluster version. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.apply_host_template(cluster_name, host_template_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str host_template_name: Host template to apply. (required)
        :param ApiHostRefList body: List of hosts to apply the host template to.
        :param bool run_config_rules: Whether to run the rules engine to automatically configure roles present on the hosts
        :param bool start_roles: Whether to start the newly created roles or not.
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.apply_host_template_with_http_info(cluster_name, host_template_name, **kwargs)  # noqa: E501
        else:
            (data) = self.apply_host_template_with_http_info(cluster_name, host_template_name, **kwargs)  # noqa: E501
            return data

    def apply_host_template_with_http_info(self, cluster_name, host_template_name, **kwargs):  # noqa: E501
        """Applies a host template to a collection of hosts.  # noqa: E501

        Applies a host template to a collection of hosts. This will create a role for each role config group on each of the hosts. <p> The provided hosts must not have any existing roles on them and if the cluster is not using parcels, the hosts must have a CDH version matching that of the cluster version. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.apply_host_template_with_http_info(cluster_name, host_template_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str host_template_name: Host template to apply. (required)
        :param ApiHostRefList body: List of hosts to apply the host template to.
        :param bool run_config_rules: Whether to run the rules engine to automatically configure roles present on the hosts
        :param bool start_roles: Whether to start the newly created roles or not.
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'host_template_name', 'body', 'run_config_rules', 'start_roles']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method apply_host_template" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `apply_host_template`")  # noqa: E501
        # verify the required parameter 'host_template_name' is set
        if ('host_template_name' not in params or
                params['host_template_name'] is None):
            raise ValueError("Missing the required parameter `host_template_name` when calling `apply_host_template`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501
        if 'host_template_name' in params:
            path_params['hostTemplateName'] = params['host_template_name']  # noqa: E501

        query_params = []
        if 'run_config_rules' in params:
            query_params.append(('runConfigRules', params['run_config_rules']))  # noqa: E501
        if 'start_roles' in params:
            query_params.append(('startRoles', params['start_roles']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/clusters/{clusterName}/hostTemplates/{hostTemplateName}/commands/applyHostTemplate', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiCommand',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def create_host_templates(self, cluster_name, **kwargs):  # noqa: E501
        """Creates new host templates.  # noqa: E501

        Creates new host templates. <p> Host template names must be unique across clusters. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_host_templates(cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param ApiHostTemplateList body: The list of host templates to create.
        :return: ApiHostTemplateList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_host_templates_with_http_info(cluster_name, **kwargs)  # noqa: E501
        else:
            (data) = self.create_host_templates_with_http_info(cluster_name, **kwargs)  # noqa: E501
            return data

    def create_host_templates_with_http_info(self, cluster_name, **kwargs):  # noqa: E501
        """Creates new host templates.  # noqa: E501

        Creates new host templates. <p> Host template names must be unique across clusters. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_host_templates_with_http_info(cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param ApiHostTemplateList body: The list of host templates to create.
        :return: ApiHostTemplateList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_host_templates" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `create_host_templates`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/clusters/{clusterName}/hostTemplates', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiHostTemplateList',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_host_template(self, cluster_name, host_template_name, **kwargs):  # noqa: E501
        """Deletes a host template.  # noqa: E501

        Deletes a host template. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_host_template(cluster_name, host_template_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str host_template_name: Host template to delete. (required)
        :return: ApiHostTemplate
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_host_template_with_http_info(cluster_name, host_template_name, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_host_template_with_http_info(cluster_name, host_template_name, **kwargs)  # noqa: E501
            return data

    def delete_host_template_with_http_info(self, cluster_name, host_template_name, **kwargs):  # noqa: E501
        """Deletes a host template.  # noqa: E501

        Deletes a host template. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_host_template_with_http_info(cluster_name, host_template_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str host_template_name: Host template to delete. (required)
        :return: ApiHostTemplate
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'host_template_name']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_host_template" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `delete_host_template`")  # noqa: E501
        # verify the required parameter 'host_template_name' is set
        if ('host_template_name' not in params or
                params['host_template_name'] is None):
            raise ValueError("Missing the required parameter `host_template_name` when calling `delete_host_template`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501
        if 'host_template_name' in params:
            path_params['hostTemplateName'] = params['host_template_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/clusters/{clusterName}/hostTemplates/{hostTemplateName}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiHostTemplate',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def read_host_template(self, cluster_name, host_template_name, **kwargs):  # noqa: E501
        """Retrieves information about a host template.  # noqa: E501

        Retrieves information about a host template. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.read_host_template(cluster_name, host_template_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str host_template_name: (required)
        :return: ApiHostTemplate
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.read_host_template_with_http_info(cluster_name, host_template_name, **kwargs)  # noqa: E501
        else:
            (data) = self.read_host_template_with_http_info(cluster_name, host_template_name, **kwargs)  # noqa: E501
            return data

    def read_host_template_with_http_info(self, cluster_name, host_template_name, **kwargs):  # noqa: E501
        """Retrieves information about a host template.  # noqa: E501

        Retrieves information about a host template. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.read_host_template_with_http_info(cluster_name, host_template_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str host_template_name: (required)
        :return: ApiHostTemplate
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'host_template_name']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method read_host_template" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `read_host_template`")  # noqa: E501
        # verify the required parameter 'host_template_name' is set
        if ('host_template_name' not in params or
                params['host_template_name'] is None):
            raise ValueError("Missing the required parameter `host_template_name` when calling `read_host_template`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501
        if 'host_template_name' in params:
            path_params['hostTemplateName'] = params['host_template_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/clusters/{clusterName}/hostTemplates/{hostTemplateName}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiHostTemplate',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def read_host_templates(self, cluster_name, **kwargs):  # noqa: E501
        """Lists all host templates in a cluster.  # noqa: E501

        Lists all host templates in a cluster. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.read_host_templates(cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :return: ApiHostTemplateList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.read_host_templates_with_http_info(cluster_name, **kwargs)  # noqa: E501
        else:
            (data) = self.read_host_templates_with_http_info(cluster_name, **kwargs)  # noqa: E501
            return data

    def read_host_templates_with_http_info(self, cluster_name, **kwargs):  # noqa: E501
        """Lists all host templates in a cluster.  # noqa: E501

        Lists all host templates in a cluster. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.read_host_templates_with_http_info(cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :return: ApiHostTemplateList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method read_host_templates" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `read_host_templates`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/clusters/{clusterName}/hostTemplates', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiHostTemplateList',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def reapply_host_template_on_hosts(self, cluster_name, host_template_name, **kwargs):  # noqa: E501
        """Reapplies a host template on all the hosts associated with the host template.  # noqa: E501

        Reapplies a host template on all the hosts associated with the host template. This will run apply host template command on the all the hosts using the host template  . <p> Set deleteRoles to true to delete the roles on the associated hosts if RCG is missing from host template. Check host tags with name as _cldr_cm_host_template_name to find out hosts using with the host template. <p> Available since API v46.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.reapply_host_template_on_hosts(cluster_name, host_template_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str host_template_name: Host template to apply. (required)
        :param bool delete_roles: Whether to delete roles on host if RCG is deleted from host template .
        :param bool start_roles: Whether to start the newly created roles or not.
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.reapply_host_template_on_hosts_with_http_info(cluster_name, host_template_name, **kwargs)  # noqa: E501
        else:
            (data) = self.reapply_host_template_on_hosts_with_http_info(cluster_name, host_template_name, **kwargs)  # noqa: E501
            return data

    def reapply_host_template_on_hosts_with_http_info(self, cluster_name, host_template_name, **kwargs):  # noqa: E501
        """Reapplies a host template on all the hosts associated with the host template.  # noqa: E501

        Reapplies a host template on all the hosts associated with the host template. This will run apply host template command on the all the hosts using the host template  . <p> Set deleteRoles to true to delete the roles on the associated hosts if RCG is missing from host template. Check host tags with name as _cldr_cm_host_template_name to find out hosts using with the host template. <p> Available since API v46.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.reapply_host_template_on_hosts_with_http_info(cluster_name, host_template_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str host_template_name: Host template to apply. (required)
        :param bool delete_roles: Whether to delete roles on host if RCG is deleted from host template .
        :param bool start_roles: Whether to start the newly created roles or not.
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'host_template_name', 'delete_roles', 'start_roles']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method reapply_host_template_on_hosts" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `reapply_host_template_on_hosts`")  # noqa: E501
        # verify the required parameter 'host_template_name' is set
        if ('host_template_name' not in params or
                params['host_template_name'] is None):
            raise ValueError("Missing the required parameter `host_template_name` when calling `reapply_host_template_on_hosts`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501
        if 'host_template_name' in params:
            path_params['hostTemplateName'] = params['host_template_name']  # noqa: E501

        query_params = []
        if 'delete_roles' in params:
            query_params.append(('deleteRoles', params['delete_roles']))  # noqa: E501
        if 'start_roles' in params:
            query_params.append(('startRoles', params['start_roles']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/clusters/{clusterName}/hostTemplates/{hostTemplateName}/commands/reapplyHostTemplateOnHosts', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiCommand',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_host_template(self, cluster_name, host_template_name, **kwargs):  # noqa: E501
        """Updates an existing host template.  # noqa: E501

        Updates an existing host template. <p> Can be used to update the role config groups in a host template or rename it. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_host_template(cluster_name, host_template_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str host_template_name: Host template with updated fields. (required)
        :param ApiHostTemplate body:
        :return: ApiHostTemplate
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_host_template_with_http_info(cluster_name, host_template_name, **kwargs)  # noqa: E501
        else:
            (data) = self.update_host_template_with_http_info(cluster_name, host_template_name, **kwargs)  # noqa: E501
            return data

    def update_host_template_with_http_info(self, cluster_name, host_template_name, **kwargs):  # noqa: E501
        """Updates an existing host template.  # noqa: E501

        Updates an existing host template. <p> Can be used to update the role config groups in a host template or rename it. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_host_template_with_http_info(cluster_name, host_template_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str host_template_name: Host template with updated fields. (required)
        :param ApiHostTemplate body:
        :return: ApiHostTemplate
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'host_template_name', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_host_template" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `update_host_template`")  # noqa: E501
        # verify the required parameter 'host_template_name' is set
        if ('host_template_name' not in params or
                params['host_template_name'] is None):
            raise ValueError("Missing the required parameter `host_template_name` when calling `update_host_template`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501
        if 'host_template_name' in params:
            path_params['hostTemplateName'] = params['host_template_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/clusters/{clusterName}/hostTemplates/{hostTemplateName}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiHostTemplate',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
