# coding: utf-8

"""
    Cloudera Manager API

    <h1>Cloudera Manager API v57</h1>       <p>Introduced in Cloudera Manager 7.13.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>  # noqa: E501

    OpenAPI spec version: 7.13.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from cm_client.api_client import ApiClient


class MgmtRoleConfigGroupsResourceApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def read_config(self, role_config_group_name, **kwargs):  # noqa: E501
        """Returns the current revision of the config for the specified role config group in the Cloudera Management Services.  # noqa: E501

        Returns the current revision of the config for the specified role config group in the Cloudera Management Services. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.read_config(role_config_group_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str role_config_group_name: The name of the role config group. (required)
        :param str view: The view of the data to materialize, either \"summary\" or \"full\".
        :return: ApiConfigList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.read_config_with_http_info(role_config_group_name, **kwargs)  # noqa: E501
        else:
            (data) = self.read_config_with_http_info(role_config_group_name, **kwargs)  # noqa: E501
            return data

    def read_config_with_http_info(self, role_config_group_name, **kwargs):  # noqa: E501
        """Returns the current revision of the config for the specified role config group in the Cloudera Management Services.  # noqa: E501

        Returns the current revision of the config for the specified role config group in the Cloudera Management Services. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.read_config_with_http_info(role_config_group_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str role_config_group_name: The name of the role config group. (required)
        :param str view: The view of the data to materialize, either \"summary\" or \"full\".
        :return: ApiConfigList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['role_config_group_name', 'view']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method read_config" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'role_config_group_name' is set
        if ('role_config_group_name' not in params or
                params['role_config_group_name'] is None):
            raise ValueError("Missing the required parameter `role_config_group_name` when calling `read_config`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'role_config_group_name' in params:
            path_params['roleConfigGroupName'] = params['role_config_group_name']  # noqa: E501

        query_params = []
        if 'view' in params:
            query_params.append(('view', params['view']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/cm/service/roleConfigGroups/{roleConfigGroupName}/config', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiConfigList',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def read_role_config_group(self, role_config_group_name, **kwargs):  # noqa: E501
        """Returns the information for a given role config group in the Cloudera Management Services.  # noqa: E501

        Returns the information for a given role config group in the Cloudera Management Services. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.read_role_config_group(role_config_group_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str role_config_group_name: The name of the requested group. (required)
        :return: ApiRoleConfigGroup
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.read_role_config_group_with_http_info(role_config_group_name, **kwargs)  # noqa: E501
        else:
            (data) = self.read_role_config_group_with_http_info(role_config_group_name, **kwargs)  # noqa: E501
            return data

    def read_role_config_group_with_http_info(self, role_config_group_name, **kwargs):  # noqa: E501
        """Returns the information for a given role config group in the Cloudera Management Services.  # noqa: E501

        Returns the information for a given role config group in the Cloudera Management Services. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.read_role_config_group_with_http_info(role_config_group_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str role_config_group_name: The name of the requested group. (required)
        :return: ApiRoleConfigGroup
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['role_config_group_name']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method read_role_config_group" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'role_config_group_name' is set
        if ('role_config_group_name' not in params or
                params['role_config_group_name'] is None):
            raise ValueError("Missing the required parameter `role_config_group_name` when calling `read_role_config_group`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'role_config_group_name' in params:
            path_params['roleConfigGroupName'] = params['role_config_group_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/cm/service/roleConfigGroups/{roleConfigGroupName}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiRoleConfigGroup',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def read_role_config_groups(self, **kwargs):  # noqa: E501
        """Returns the information for all role config groups in the Cloudera Management Services.  # noqa: E501

        Returns the information for all role config groups in the Cloudera Management Services. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.read_role_config_groups(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: ApiRoleConfigGroupList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.read_role_config_groups_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.read_role_config_groups_with_http_info(**kwargs)  # noqa: E501
            return data

    def read_role_config_groups_with_http_info(self, **kwargs):  # noqa: E501
        """Returns the information for all role config groups in the Cloudera Management Services.  # noqa: E501

        Returns the information for all role config groups in the Cloudera Management Services. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.read_role_config_groups_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: ApiRoleConfigGroupList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method read_role_config_groups" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/cm/service/roleConfigGroups', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiRoleConfigGroupList',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def read_roles(self, role_config_group_name, **kwargs):  # noqa: E501
        """Returns all roles in the given role config group in the Cloudera Management Services.  # noqa: E501

        Returns all roles in the given role config group in the Cloudera Management Services. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.read_roles(role_config_group_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str role_config_group_name: The name of the role config group. (required)
        :return: ApiRoleList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.read_roles_with_http_info(role_config_group_name, **kwargs)  # noqa: E501
        else:
            (data) = self.read_roles_with_http_info(role_config_group_name, **kwargs)  # noqa: E501
            return data

    def read_roles_with_http_info(self, role_config_group_name, **kwargs):  # noqa: E501
        """Returns all roles in the given role config group in the Cloudera Management Services.  # noqa: E501

        Returns all roles in the given role config group in the Cloudera Management Services. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.read_roles_with_http_info(role_config_group_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str role_config_group_name: The name of the role config group. (required)
        :return: ApiRoleList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['role_config_group_name']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method read_roles" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'role_config_group_name' is set
        if ('role_config_group_name' not in params or
                params['role_config_group_name'] is None):
            raise ValueError("Missing the required parameter `role_config_group_name` when calling `read_roles`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'role_config_group_name' in params:
            path_params['roleConfigGroupName'] = params['role_config_group_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/cm/service/roleConfigGroups/{roleConfigGroupName}/roles', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiRoleList',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_config(self, role_config_group_name, **kwargs):  # noqa: E501
        """Updates the config for the given role config group in the Cloudera Management Services.  # noqa: E501

        Updates the config for the given role config group in the Cloudera Management Services. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_config(role_config_group_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str role_config_group_name: The name of the role config group. (required)
        :param ApiConfigList body: The new config information for the group.
        :param str message: Optional message describing the changes.
        :return: ApiConfigList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_config_with_http_info(role_config_group_name, **kwargs)  # noqa: E501
        else:
            (data) = self.update_config_with_http_info(role_config_group_name, **kwargs)  # noqa: E501
            return data

    def update_config_with_http_info(self, role_config_group_name, **kwargs):  # noqa: E501
        """Updates the config for the given role config group in the Cloudera Management Services.  # noqa: E501

        Updates the config for the given role config group in the Cloudera Management Services. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_config_with_http_info(role_config_group_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str role_config_group_name: The name of the role config group. (required)
        :param ApiConfigList body: The new config information for the group.
        :param str message: Optional message describing the changes.
        :return: ApiConfigList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['role_config_group_name', 'body', 'message']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_config" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'role_config_group_name' is set
        if ('role_config_group_name' not in params or
                params['role_config_group_name'] is None):
            raise ValueError("Missing the required parameter `role_config_group_name` when calling `update_config`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'role_config_group_name' in params:
            path_params['roleConfigGroupName'] = params['role_config_group_name']  # noqa: E501

        query_params = []
        if 'message' in params:
            query_params.append(('message', params['message']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/cm/service/roleConfigGroups/{roleConfigGroupName}/config', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiConfigList',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_role_config_group(self, role_config_group_name, **kwargs):  # noqa: E501
        """Updates an existing role config group in the Cloudera Management Services.  # noqa: E501

        Updates an existing role config group in the Cloudera Management Services. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_role_config_group(role_config_group_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str role_config_group_name: The name of the group to update. (required)
        :param ApiRoleConfigGroup body: The updated role config group.
        :param str message: The optional message describing the changes.
        :return: ApiRoleConfigGroup
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_role_config_group_with_http_info(role_config_group_name, **kwargs)  # noqa: E501
        else:
            (data) = self.update_role_config_group_with_http_info(role_config_group_name, **kwargs)  # noqa: E501
            return data

    def update_role_config_group_with_http_info(self, role_config_group_name, **kwargs):  # noqa: E501
        """Updates an existing role config group in the Cloudera Management Services.  # noqa: E501

        Updates an existing role config group in the Cloudera Management Services. <p> Available since API v3.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_role_config_group_with_http_info(role_config_group_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str role_config_group_name: The name of the group to update. (required)
        :param ApiRoleConfigGroup body: The updated role config group.
        :param str message: The optional message describing the changes.
        :return: ApiRoleConfigGroup
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['role_config_group_name', 'body', 'message']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_role_config_group" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'role_config_group_name' is set
        if ('role_config_group_name' not in params or
                params['role_config_group_name'] is None):
            raise ValueError("Missing the required parameter `role_config_group_name` when calling `update_role_config_group`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'role_config_group_name' in params:
            path_params['roleConfigGroupName'] = params['role_config_group_name']  # noqa: E501

        query_params = []
        if 'message' in params:
            query_params.append(('message', params['message']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/cm/service/roleConfigGroups/{roleConfigGroupName}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiRoleConfigGroup',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
