# coding: utf-8

"""
    Cloudera Manager API

    <h1>Cloudera Manager API v57</h1>       <p>Introduced in Cloudera Manager 7.13.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>  # noqa: E501

    OpenAPI spec version: 7.13.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from cm_client.api_client import ApiClient


class SnapshotsResourceApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_h_base_snapshot_from_remote(self, cluster_name, service_name, **kwargs):  # noqa: E501
        """create_h_base_snapshot_from_remote  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_h_base_snapshot_from_remote(cluster_name, service_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str service_name: (required)
        :param ApiHBaseSnapshot body:
        :param int bandwidth_per_map:
        :param bool direct_copy:
        :param str external_account:
        :param int num_mappers:
        :param str run_as_user:
        :param str scheduler_pool_name:
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_h_base_snapshot_from_remote_with_http_info(cluster_name, service_name, **kwargs)  # noqa: E501
        else:
            (data) = self.create_h_base_snapshot_from_remote_with_http_info(cluster_name, service_name, **kwargs)  # noqa: E501
            return data

    def create_h_base_snapshot_from_remote_with_http_info(self, cluster_name, service_name, **kwargs):  # noqa: E501
        """create_h_base_snapshot_from_remote  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_h_base_snapshot_from_remote_with_http_info(cluster_name, service_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str service_name: (required)
        :param ApiHBaseSnapshot body:
        :param int bandwidth_per_map:
        :param bool direct_copy:
        :param str external_account:
        :param int num_mappers:
        :param str run_as_user:
        :param str scheduler_pool_name:
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'service_name', 'body', 'bandwidth_per_map', 'direct_copy', 'external_account', 'num_mappers', 'run_as_user', 'scheduler_pool_name']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_h_base_snapshot_from_remote" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `create_h_base_snapshot_from_remote`")  # noqa: E501
        # verify the required parameter 'service_name' is set
        if ('service_name' not in params or
                params['service_name'] is None):
            raise ValueError("Missing the required parameter `service_name` when calling `create_h_base_snapshot_from_remote`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501
        if 'service_name' in params:
            path_params['serviceName'] = params['service_name']  # noqa: E501

        query_params = []
        if 'bandwidth_per_map' in params:
            query_params.append(('bandwidthPerMap', params['bandwidth_per_map']))  # noqa: E501
        if 'direct_copy' in params:
            query_params.append(('directCopy', params['direct_copy']))  # noqa: E501
        if 'external_account' in params:
            query_params.append(('externalAccount', params['external_account']))  # noqa: E501
        if 'num_mappers' in params:
            query_params.append(('numMappers', params['num_mappers']))  # noqa: E501
        if 'run_as_user' in params:
            query_params.append(('runAsUser', params['run_as_user']))  # noqa: E501
        if 'scheduler_pool_name' in params:
            query_params.append(('schedulerPoolName', params['scheduler_pool_name']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/clusters/{clusterName}/services/{serviceName}/snapshots', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiCommand',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def create_policies(self, cluster_name, service_name, **kwargs):  # noqa: E501
        """Creates one or more snapshot policies.  # noqa: E501

        Creates one or more snapshot policies.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_policies(cluster_name, service_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str service_name: (required)
        :param ApiSnapshotPolicyList body: List of the snapshot policies to create.
        :return: ApiSnapshotPolicyList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_policies_with_http_info(cluster_name, service_name, **kwargs)  # noqa: E501
        else:
            (data) = self.create_policies_with_http_info(cluster_name, service_name, **kwargs)  # noqa: E501
            return data

    def create_policies_with_http_info(self, cluster_name, service_name, **kwargs):  # noqa: E501
        """Creates one or more snapshot policies.  # noqa: E501

        Creates one or more snapshot policies.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_policies_with_http_info(cluster_name, service_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str service_name: (required)
        :param ApiSnapshotPolicyList body: List of the snapshot policies to create.
        :return: ApiSnapshotPolicyList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'service_name', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_policies" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `create_policies`")  # noqa: E501
        # verify the required parameter 'service_name' is set
        if ('service_name' not in params or
                params['service_name'] is None):
            raise ValueError("Missing the required parameter `service_name` when calling `create_policies`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501
        if 'service_name' in params:
            path_params['serviceName'] = params['service_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/clusters/{clusterName}/services/{serviceName}/snapshots/policies', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiSnapshotPolicyList',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_policy(self, cluster_name, policy_name, service_name, **kwargs):  # noqa: E501
        """Deletes an existing snapshot policy.  # noqa: E501

        Deletes an existing snapshot policy.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_policy(cluster_name, policy_name, service_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str policy_name: Name of an existing snapshot policy. (required)
        :param str service_name: (required)
        :return: ApiSnapshotPolicy
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_policy_with_http_info(cluster_name, policy_name, service_name, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_policy_with_http_info(cluster_name, policy_name, service_name, **kwargs)  # noqa: E501
            return data

    def delete_policy_with_http_info(self, cluster_name, policy_name, service_name, **kwargs):  # noqa: E501
        """Deletes an existing snapshot policy.  # noqa: E501

        Deletes an existing snapshot policy.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_policy_with_http_info(cluster_name, policy_name, service_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str policy_name: Name of an existing snapshot policy. (required)
        :param str service_name: (required)
        :return: ApiSnapshotPolicy
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'policy_name', 'service_name']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_policy" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `delete_policy`")  # noqa: E501
        # verify the required parameter 'policy_name' is set
        if ('policy_name' not in params or
                params['policy_name'] is None):
            raise ValueError("Missing the required parameter `policy_name` when calling `delete_policy`")  # noqa: E501
        # verify the required parameter 'service_name' is set
        if ('service_name' not in params or
                params['service_name'] is None):
            raise ValueError("Missing the required parameter `service_name` when calling `delete_policy`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501
        if 'policy_name' in params:
            path_params['policyName'] = params['policy_name']  # noqa: E501
        if 'service_name' in params:
            path_params['serviceName'] = params['service_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/clusters/{clusterName}/services/{serviceName}/snapshots/policies/{policyName}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiSnapshotPolicy',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_h_base_snapshots_command(self, cluster_name, service_name, **kwargs):  # noqa: E501
        """Starts a command that lists the available HBase snapshots from S3 or local HBase service.  # noqa: E501

        Starts a command that lists the available HBase snapshots from S3 or local HBase service. If a table name is provided, it will list the snapshots for that table only, otherwise it will list all available snapshots.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_h_base_snapshots_command(cluster_name, service_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str service_name: (required)
        :param str storage: Location from where the snapshots should be fetched.
        :param str storage_location: Location of remote snapshots, if other than the local storage should be used.
        :param str table_name: Table for which to list snapshots. If null is provided, it will list all snapshots for all tables.
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_h_base_snapshots_command_with_http_info(cluster_name, service_name, **kwargs)  # noqa: E501
        else:
            (data) = self.list_h_base_snapshots_command_with_http_info(cluster_name, service_name, **kwargs)  # noqa: E501
            return data

    def list_h_base_snapshots_command_with_http_info(self, cluster_name, service_name, **kwargs):  # noqa: E501
        """Starts a command that lists the available HBase snapshots from S3 or local HBase service.  # noqa: E501

        Starts a command that lists the available HBase snapshots from S3 or local HBase service. If a table name is provided, it will list the snapshots for that table only, otherwise it will list all available snapshots.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_h_base_snapshots_command_with_http_info(cluster_name, service_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str service_name: (required)
        :param str storage: Location from where the snapshots should be fetched.
        :param str storage_location: Location of remote snapshots, if other than the local storage should be used.
        :param str table_name: Table for which to list snapshots. If null is provided, it will list all snapshots for all tables.
        :return: ApiCommand
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'service_name', 'storage', 'storage_location', 'table_name']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_h_base_snapshots_command" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `list_h_base_snapshots_command`")  # noqa: E501
        # verify the required parameter 'service_name' is set
        if ('service_name' not in params or
                params['service_name'] is None):
            raise ValueError("Missing the required parameter `service_name` when calling `list_h_base_snapshots_command`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501
        if 'service_name' in params:
            path_params['serviceName'] = params['service_name']  # noqa: E501

        query_params = []
        if 'storage' in params:
            query_params.append(('storage', params['storage']))  # noqa: E501
        if 'storage_location' in params:
            query_params.append(('storageLocation', params['storage_location']))  # noqa: E501
        if 'table_name' in params:
            query_params.append(('tableName', params['table_name']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/clusters/{clusterName}/services/{serviceName}/snapshots/listHBaseSnapshotsCommand', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiCommand',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def read_history(self, cluster_name, policy_name, service_name, **kwargs):  # noqa: E501
        """Returns a list of commands triggered by a snapshot policy.  # noqa: E501

        Returns a list of commands triggered by a snapshot policy.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.read_history(cluster_name, policy_name, service_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str policy_name: Name of an existing snapshot policy. (required)
        :param str service_name: (required)
        :param int limit: Maximum number of commands to retrieve.
        :param int offset: Index of first command to retrieve.
        :param str view: The view to materialize.
        :return: ApiSnapshotCommandList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.read_history_with_http_info(cluster_name, policy_name, service_name, **kwargs)  # noqa: E501
        else:
            (data) = self.read_history_with_http_info(cluster_name, policy_name, service_name, **kwargs)  # noqa: E501
            return data

    def read_history_with_http_info(self, cluster_name, policy_name, service_name, **kwargs):  # noqa: E501
        """Returns a list of commands triggered by a snapshot policy.  # noqa: E501

        Returns a list of commands triggered by a snapshot policy.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.read_history_with_http_info(cluster_name, policy_name, service_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str policy_name: Name of an existing snapshot policy. (required)
        :param str service_name: (required)
        :param int limit: Maximum number of commands to retrieve.
        :param int offset: Index of first command to retrieve.
        :param str view: The view to materialize.
        :return: ApiSnapshotCommandList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'policy_name', 'service_name', 'limit', 'offset', 'view']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method read_history" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `read_history`")  # noqa: E501
        # verify the required parameter 'policy_name' is set
        if ('policy_name' not in params or
                params['policy_name'] is None):
            raise ValueError("Missing the required parameter `policy_name` when calling `read_history`")  # noqa: E501
        # verify the required parameter 'service_name' is set
        if ('service_name' not in params or
                params['service_name'] is None):
            raise ValueError("Missing the required parameter `service_name` when calling `read_history`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501
        if 'policy_name' in params:
            path_params['policyName'] = params['policy_name']  # noqa: E501
        if 'service_name' in params:
            path_params['serviceName'] = params['service_name']  # noqa: E501

        query_params = []
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501
        if 'offset' in params:
            query_params.append(('offset', params['offset']))  # noqa: E501
        if 'view' in params:
            query_params.append(('view', params['view']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/clusters/{clusterName}/services/{serviceName}/snapshots/policies/{policyName}/history', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiSnapshotCommandList',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def read_policies(self, cluster_name, service_name, **kwargs):  # noqa: E501
        """Returns information for all snapshot policies.  # noqa: E501

        Returns information for all snapshot policies.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.read_policies(cluster_name, service_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str service_name: (required)
        :param str view: The view to materialize.
        :return: ApiSnapshotPolicyList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.read_policies_with_http_info(cluster_name, service_name, **kwargs)  # noqa: E501
        else:
            (data) = self.read_policies_with_http_info(cluster_name, service_name, **kwargs)  # noqa: E501
            return data

    def read_policies_with_http_info(self, cluster_name, service_name, **kwargs):  # noqa: E501
        """Returns information for all snapshot policies.  # noqa: E501

        Returns information for all snapshot policies.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.read_policies_with_http_info(cluster_name, service_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str service_name: (required)
        :param str view: The view to materialize.
        :return: ApiSnapshotPolicyList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'service_name', 'view']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method read_policies" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `read_policies`")  # noqa: E501
        # verify the required parameter 'service_name' is set
        if ('service_name' not in params or
                params['service_name'] is None):
            raise ValueError("Missing the required parameter `service_name` when calling `read_policies`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501
        if 'service_name' in params:
            path_params['serviceName'] = params['service_name']  # noqa: E501

        query_params = []
        if 'view' in params:
            query_params.append(('view', params['view']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/clusters/{clusterName}/services/{serviceName}/snapshots/policies', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiSnapshotPolicyList',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def read_policy(self, cluster_name, policy_name, service_name, **kwargs):  # noqa: E501
        """Returns information for a specific snapshot policy.  # noqa: E501

        Returns information for a specific snapshot policy.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.read_policy(cluster_name, policy_name, service_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str policy_name: Name of an existing snapshot policy. (required)
        :param str service_name: (required)
        :param str view: The view to materialize.
        :return: ApiSnapshotPolicy
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.read_policy_with_http_info(cluster_name, policy_name, service_name, **kwargs)  # noqa: E501
        else:
            (data) = self.read_policy_with_http_info(cluster_name, policy_name, service_name, **kwargs)  # noqa: E501
            return data

    def read_policy_with_http_info(self, cluster_name, policy_name, service_name, **kwargs):  # noqa: E501
        """Returns information for a specific snapshot policy.  # noqa: E501

        Returns information for a specific snapshot policy.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.read_policy_with_http_info(cluster_name, policy_name, service_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str policy_name: Name of an existing snapshot policy. (required)
        :param str service_name: (required)
        :param str view: The view to materialize.
        :return: ApiSnapshotPolicy
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'policy_name', 'service_name', 'view']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method read_policy" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `read_policy`")  # noqa: E501
        # verify the required parameter 'policy_name' is set
        if ('policy_name' not in params or
                params['policy_name'] is None):
            raise ValueError("Missing the required parameter `policy_name` when calling `read_policy`")  # noqa: E501
        # verify the required parameter 'service_name' is set
        if ('service_name' not in params or
                params['service_name'] is None):
            raise ValueError("Missing the required parameter `service_name` when calling `read_policy`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501
        if 'policy_name' in params:
            path_params['policyName'] = params['policy_name']  # noqa: E501
        if 'service_name' in params:
            path_params['serviceName'] = params['service_name']  # noqa: E501

        query_params = []
        if 'view' in params:
            query_params.append(('view', params['view']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/clusters/{clusterName}/services/{serviceName}/snapshots/policies/{policyName}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiSnapshotPolicy',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_policy(self, cluster_name, policy_name, service_name, **kwargs):  # noqa: E501
        """Updates an existing snapshot policy.  # noqa: E501

        Updates an existing snapshot policy.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_policy(cluster_name, policy_name, service_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str policy_name: Name of an existing snapshot policy. (required)
        :param str service_name: (required)
        :param ApiSnapshotPolicy body: Modified policy.
        :return: ApiSnapshotPolicy
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_policy_with_http_info(cluster_name, policy_name, service_name, **kwargs)  # noqa: E501
        else:
            (data) = self.update_policy_with_http_info(cluster_name, policy_name, service_name, **kwargs)  # noqa: E501
            return data

    def update_policy_with_http_info(self, cluster_name, policy_name, service_name, **kwargs):  # noqa: E501
        """Updates an existing snapshot policy.  # noqa: E501

        Updates an existing snapshot policy.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_policy_with_http_info(cluster_name, policy_name, service_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: (required)
        :param str policy_name: Name of an existing snapshot policy. (required)
        :param str service_name: (required)
        :param ApiSnapshotPolicy body: Modified policy.
        :return: ApiSnapshotPolicy
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'policy_name', 'service_name', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_policy" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `update_policy`")  # noqa: E501
        # verify the required parameter 'policy_name' is set
        if ('policy_name' not in params or
                params['policy_name'] is None):
            raise ValueError("Missing the required parameter `policy_name` when calling `update_policy`")  # noqa: E501
        # verify the required parameter 'service_name' is set
        if ('service_name' not in params or
                params['service_name'] is None):
            raise ValueError("Missing the required parameter `service_name` when calling `update_policy`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501
        if 'policy_name' in params:
            path_params['policyName'] = params['policy_name']  # noqa: E501
        if 'service_name' in params:
            path_params['serviceName'] = params['service_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/clusters/{clusterName}/services/{serviceName}/snapshots/policies/{policyName}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiSnapshotPolicy',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
