# coding: utf-8

"""
    Cloudera Manager API

    <h1>Cloudera Manager API v57</h1>       <p>Introduced in Cloudera Manager 7.13.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>  # noqa: E501

    OpenAPI spec version: 7.13.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ApiHBaseReplicationArguments(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'source_h_base_service': 'ApiServiceRef',
        'peer_state': 'HBasePeerState',
        'hbase_peer_id': 'str',
        'hbase_cluster_key': 'str',
        'end_point_class_name': 'str',
        'tables': 'list[HBaseTableArgs]',
        'database': 'HBaseDatabaseArgs',
        'replication_properties': 'dict(str, str)',
        'source_account': 'str',
        'source_scheduler_pool': 'str',
        'num_mappers': 'int',
        'bandwidth_per_map': 'int',
        'export_snapshot_user': 'str',
        'snapshot_scratch_location': 'str',
        'validate_replication_setup': 'bool',
        'max_parallel_snapshots': 'int'
    }

    attribute_map = {
        'source_h_base_service': 'sourceHBaseService',
        'peer_state': 'peerState',
        'hbase_peer_id': 'hbasePeerId',
        'hbase_cluster_key': 'hbaseClusterKey',
        'end_point_class_name': 'endPointClassName',
        'tables': 'tables',
        'database': 'database',
        'replication_properties': 'replicationProperties',
        'source_account': 'sourceAccount',
        'source_scheduler_pool': 'sourceSchedulerPool',
        'num_mappers': 'numMappers',
        'bandwidth_per_map': 'bandwidthPerMap',
        'export_snapshot_user': 'exportSnapshotUser',
        'snapshot_scratch_location': 'snapshotScratchLocation',
        'validate_replication_setup': 'validateReplicationSetup',
        'max_parallel_snapshots': 'maxParallelSnapshots'
    }

    def __init__(self, source_h_base_service=None, peer_state=None, hbase_peer_id=None, hbase_cluster_key=None, end_point_class_name=None, tables=None, database=None, replication_properties=None, source_account=None, source_scheduler_pool=None, num_mappers=None, bandwidth_per_map=None, export_snapshot_user=None, snapshot_scratch_location=None, validate_replication_setup=None, max_parallel_snapshots=None):  # noqa: E501
        """ApiHBaseReplicationArguments - a model defined in Swagger"""  # noqa: E501
        self._source_h_base_service = None
        self._peer_state = None
        self._hbase_peer_id = None
        self._hbase_cluster_key = None
        self._end_point_class_name = None
        self._tables = None
        self._database = None
        self._replication_properties = None
        self._source_account = None
        self._source_scheduler_pool = None
        self._num_mappers = None
        self._bandwidth_per_map = None
        self._export_snapshot_user = None
        self._snapshot_scratch_location = None
        self._validate_replication_setup = None
        self._max_parallel_snapshots = None
        self.discriminator = None
        if source_h_base_service is not None:
            self.source_h_base_service = source_h_base_service
        if peer_state is not None:
            self.peer_state = peer_state
        if hbase_peer_id is not None:
            self.hbase_peer_id = hbase_peer_id
        if hbase_cluster_key is not None:
            self.hbase_cluster_key = hbase_cluster_key
        if end_point_class_name is not None:
            self.end_point_class_name = end_point_class_name
        if tables is not None:
            self.tables = tables
        if database is not None:
            self.database = database
        if replication_properties is not None:
            self.replication_properties = replication_properties
        if source_account is not None:
            self.source_account = source_account
        if source_scheduler_pool is not None:
            self.source_scheduler_pool = source_scheduler_pool
        if num_mappers is not None:
            self.num_mappers = num_mappers
        if bandwidth_per_map is not None:
            self.bandwidth_per_map = bandwidth_per_map
        if export_snapshot_user is not None:
            self.export_snapshot_user = export_snapshot_user
        if snapshot_scratch_location is not None:
            self.snapshot_scratch_location = snapshot_scratch_location
        if validate_replication_setup is not None:
            self.validate_replication_setup = validate_replication_setup
        if max_parallel_snapshots is not None:
            self.max_parallel_snapshots = max_parallel_snapshots

    @property
    def source_h_base_service(self):
        """Gets the source_h_base_service of this ApiHBaseReplicationArguments.  # noqa: E501


        :return: The source_h_base_service of this ApiHBaseReplicationArguments.  # noqa: E501
        :rtype: ApiServiceRef
        """
        return self._source_h_base_service

    @source_h_base_service.setter
    def source_h_base_service(self, source_h_base_service):
        """Sets the source_h_base_service of this ApiHBaseReplicationArguments.


        :param source_h_base_service: The source_h_base_service of this ApiHBaseReplicationArguments.  # noqa: E501
        :type: ApiServiceRef
        """

        self._source_h_base_service = source_h_base_service

    @property
    def peer_state(self):
        """Gets the peer_state of this ApiHBaseReplicationArguments.  # noqa: E501


        :return: The peer_state of this ApiHBaseReplicationArguments.  # noqa: E501
        :rtype: HBasePeerState
        """
        return self._peer_state

    @peer_state.setter
    def peer_state(self, peer_state):
        """Sets the peer_state of this ApiHBaseReplicationArguments.


        :param peer_state: The peer_state of this ApiHBaseReplicationArguments.  # noqa: E501
        :type: HBasePeerState
        """

        self._peer_state = peer_state

    @property
    def hbase_peer_id(self):
        """Gets the hbase_peer_id of this ApiHBaseReplicationArguments.  # noqa: E501

        Available since API v52.  # noqa: E501

        :return: The hbase_peer_id of this ApiHBaseReplicationArguments.  # noqa: E501
        :rtype: str
        """
        return self._hbase_peer_id

    @hbase_peer_id.setter
    def hbase_peer_id(self, hbase_peer_id):
        """Sets the hbase_peer_id of this ApiHBaseReplicationArguments.

        Available since API v52.  # noqa: E501

        :param hbase_peer_id: The hbase_peer_id of this ApiHBaseReplicationArguments.  # noqa: E501
        :type: str
        """

        self._hbase_peer_id = hbase_peer_id

    @property
    def hbase_cluster_key(self):
        """Gets the hbase_cluster_key of this ApiHBaseReplicationArguments.  # noqa: E501


        :return: The hbase_cluster_key of this ApiHBaseReplicationArguments.  # noqa: E501
        :rtype: str
        """
        return self._hbase_cluster_key

    @hbase_cluster_key.setter
    def hbase_cluster_key(self, hbase_cluster_key):
        """Sets the hbase_cluster_key of this ApiHBaseReplicationArguments.


        :param hbase_cluster_key: The hbase_cluster_key of this ApiHBaseReplicationArguments.  # noqa: E501
        :type: str
        """

        self._hbase_cluster_key = hbase_cluster_key

    @property
    def end_point_class_name(self):
        """Gets the end_point_class_name of this ApiHBaseReplicationArguments.  # noqa: E501


        :return: The end_point_class_name of this ApiHBaseReplicationArguments.  # noqa: E501
        :rtype: str
        """
        return self._end_point_class_name

    @end_point_class_name.setter
    def end_point_class_name(self, end_point_class_name):
        """Sets the end_point_class_name of this ApiHBaseReplicationArguments.


        :param end_point_class_name: The end_point_class_name of this ApiHBaseReplicationArguments.  # noqa: E501
        :type: str
        """

        self._end_point_class_name = end_point_class_name

    @property
    def tables(self):
        """Gets the tables of this ApiHBaseReplicationArguments.  # noqa: E501


        :return: The tables of this ApiHBaseReplicationArguments.  # noqa: E501
        :rtype: list[HBaseTableArgs]
        """
        return self._tables

    @tables.setter
    def tables(self, tables):
        """Sets the tables of this ApiHBaseReplicationArguments.


        :param tables: The tables of this ApiHBaseReplicationArguments.  # noqa: E501
        :type: list[HBaseTableArgs]
        """

        self._tables = tables

    @property
    def database(self):
        """Gets the database of this ApiHBaseReplicationArguments.  # noqa: E501


        :return: The database of this ApiHBaseReplicationArguments.  # noqa: E501
        :rtype: HBaseDatabaseArgs
        """
        return self._database

    @database.setter
    def database(self, database):
        """Sets the database of this ApiHBaseReplicationArguments.


        :param database: The database of this ApiHBaseReplicationArguments.  # noqa: E501
        :type: HBaseDatabaseArgs
        """

        self._database = database

    @property
    def replication_properties(self):
        """Gets the replication_properties of this ApiHBaseReplicationArguments.  # noqa: E501


        :return: The replication_properties of this ApiHBaseReplicationArguments.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._replication_properties

    @replication_properties.setter
    def replication_properties(self, replication_properties):
        """Sets the replication_properties of this ApiHBaseReplicationArguments.


        :param replication_properties: The replication_properties of this ApiHBaseReplicationArguments.  # noqa: E501
        :type: dict(str, str)
        """

        self._replication_properties = replication_properties

    @property
    def source_account(self):
        """Gets the source_account of this ApiHBaseReplicationArguments.  # noqa: E501


        :return: The source_account of this ApiHBaseReplicationArguments.  # noqa: E501
        :rtype: str
        """
        return self._source_account

    @source_account.setter
    def source_account(self, source_account):
        """Sets the source_account of this ApiHBaseReplicationArguments.


        :param source_account: The source_account of this ApiHBaseReplicationArguments.  # noqa: E501
        :type: str
        """

        self._source_account = source_account

    @property
    def source_scheduler_pool(self):
        """Gets the source_scheduler_pool of this ApiHBaseReplicationArguments.  # noqa: E501


        :return: The source_scheduler_pool of this ApiHBaseReplicationArguments.  # noqa: E501
        :rtype: str
        """
        return self._source_scheduler_pool

    @source_scheduler_pool.setter
    def source_scheduler_pool(self, source_scheduler_pool):
        """Sets the source_scheduler_pool of this ApiHBaseReplicationArguments.


        :param source_scheduler_pool: The source_scheduler_pool of this ApiHBaseReplicationArguments.  # noqa: E501
        :type: str
        """

        self._source_scheduler_pool = source_scheduler_pool

    @property
    def num_mappers(self):
        """Gets the num_mappers of this ApiHBaseReplicationArguments.  # noqa: E501


        :return: The num_mappers of this ApiHBaseReplicationArguments.  # noqa: E501
        :rtype: int
        """
        return self._num_mappers

    @num_mappers.setter
    def num_mappers(self, num_mappers):
        """Sets the num_mappers of this ApiHBaseReplicationArguments.


        :param num_mappers: The num_mappers of this ApiHBaseReplicationArguments.  # noqa: E501
        :type: int
        """

        self._num_mappers = num_mappers

    @property
    def bandwidth_per_map(self):
        """Gets the bandwidth_per_map of this ApiHBaseReplicationArguments.  # noqa: E501


        :return: The bandwidth_per_map of this ApiHBaseReplicationArguments.  # noqa: E501
        :rtype: int
        """
        return self._bandwidth_per_map

    @bandwidth_per_map.setter
    def bandwidth_per_map(self, bandwidth_per_map):
        """Sets the bandwidth_per_map of this ApiHBaseReplicationArguments.


        :param bandwidth_per_map: The bandwidth_per_map of this ApiHBaseReplicationArguments.  # noqa: E501
        :type: int
        """

        self._bandwidth_per_map = bandwidth_per_map

    @property
    def export_snapshot_user(self):
        """Gets the export_snapshot_user of this ApiHBaseReplicationArguments.  # noqa: E501


        :return: The export_snapshot_user of this ApiHBaseReplicationArguments.  # noqa: E501
        :rtype: str
        """
        return self._export_snapshot_user

    @export_snapshot_user.setter
    def export_snapshot_user(self, export_snapshot_user):
        """Sets the export_snapshot_user of this ApiHBaseReplicationArguments.


        :param export_snapshot_user: The export_snapshot_user of this ApiHBaseReplicationArguments.  # noqa: E501
        :type: str
        """

        self._export_snapshot_user = export_snapshot_user

    @property
    def snapshot_scratch_location(self):
        """Gets the snapshot_scratch_location of this ApiHBaseReplicationArguments.  # noqa: E501


        :return: The snapshot_scratch_location of this ApiHBaseReplicationArguments.  # noqa: E501
        :rtype: str
        """
        return self._snapshot_scratch_location

    @snapshot_scratch_location.setter
    def snapshot_scratch_location(self, snapshot_scratch_location):
        """Sets the snapshot_scratch_location of this ApiHBaseReplicationArguments.


        :param snapshot_scratch_location: The snapshot_scratch_location of this ApiHBaseReplicationArguments.  # noqa: E501
        :type: str
        """

        self._snapshot_scratch_location = snapshot_scratch_location

    @property
    def validate_replication_setup(self):
        """Gets the validate_replication_setup of this ApiHBaseReplicationArguments.  # noqa: E501


        :return: The validate_replication_setup of this ApiHBaseReplicationArguments.  # noqa: E501
        :rtype: bool
        """
        return self._validate_replication_setup

    @validate_replication_setup.setter
    def validate_replication_setup(self, validate_replication_setup):
        """Sets the validate_replication_setup of this ApiHBaseReplicationArguments.


        :param validate_replication_setup: The validate_replication_setup of this ApiHBaseReplicationArguments.  # noqa: E501
        :type: bool
        """

        self._validate_replication_setup = validate_replication_setup

    @property
    def max_parallel_snapshots(self):
        """Gets the max_parallel_snapshots of this ApiHBaseReplicationArguments.  # noqa: E501


        :return: The max_parallel_snapshots of this ApiHBaseReplicationArguments.  # noqa: E501
        :rtype: int
        """
        return self._max_parallel_snapshots

    @max_parallel_snapshots.setter
    def max_parallel_snapshots(self, max_parallel_snapshots):
        """Sets the max_parallel_snapshots of this ApiHBaseReplicationArguments.


        :param max_parallel_snapshots: The max_parallel_snapshots of this ApiHBaseReplicationArguments.  # noqa: E501
        :type: int
        """

        self._max_parallel_snapshots = max_parallel_snapshots

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ApiHBaseReplicationArguments, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApiHBaseReplicationArguments):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
