# coding: utf-8

"""
    Cloudera Manager API

    <h1>Cloudera Manager API v57</h1>       <p>Introduced in Cloudera Manager 7.13.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>  # noqa: E501

    OpenAPI spec version: 7.13.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ApiHBaseSnapshot(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'snapshot_name': 'str',
        'table_name': 'str',
        'creation_time': 'str',
        'storage': 'Storage',
        'storage_location': 'str'
    }

    attribute_map = {
        'snapshot_name': 'snapshotName',
        'table_name': 'tableName',
        'creation_time': 'creationTime',
        'storage': 'storage',
        'storage_location': 'storageLocation'
    }

    def __init__(self, snapshot_name=None, table_name=None, creation_time=None, storage=None, storage_location=None):  # noqa: E501
        """ApiHBaseSnapshot - a model defined in Swagger"""  # noqa: E501
        self._snapshot_name = None
        self._table_name = None
        self._creation_time = None
        self._storage = None
        self._storage_location = None
        self.discriminator = None
        if snapshot_name is not None:
            self.snapshot_name = snapshot_name
        if table_name is not None:
            self.table_name = table_name
        if creation_time is not None:
            self.creation_time = creation_time
        if storage is not None:
            self.storage = storage
        if storage_location is not None:
            self.storage_location = storage_location

    @property
    def snapshot_name(self):
        """Gets the snapshot_name of this ApiHBaseSnapshot.  # noqa: E501

        Snapshot name.  # noqa: E501

        :return: The snapshot_name of this ApiHBaseSnapshot.  # noqa: E501
        :rtype: str
        """
        return self._snapshot_name

    @snapshot_name.setter
    def snapshot_name(self, snapshot_name):
        """Sets the snapshot_name of this ApiHBaseSnapshot.

        Snapshot name.  # noqa: E501

        :param snapshot_name: The snapshot_name of this ApiHBaseSnapshot.  # noqa: E501
        :type: str
        """

        self._snapshot_name = snapshot_name

    @property
    def table_name(self):
        """Gets the table_name of this ApiHBaseSnapshot.  # noqa: E501

        Name of the table this snapshot is for.  # noqa: E501

        :return: The table_name of this ApiHBaseSnapshot.  # noqa: E501
        :rtype: str
        """
        return self._table_name

    @table_name.setter
    def table_name(self, table_name):
        """Sets the table_name of this ApiHBaseSnapshot.

        Name of the table this snapshot is for.  # noqa: E501

        :param table_name: The table_name of this ApiHBaseSnapshot.  # noqa: E501
        :type: str
        """

        self._table_name = table_name

    @property
    def creation_time(self):
        """Gets the creation_time of this ApiHBaseSnapshot.  # noqa: E501

        Snapshot creation time.  # noqa: E501

        :return: The creation_time of this ApiHBaseSnapshot.  # noqa: E501
        :rtype: str
        """
        return self._creation_time

    @creation_time.setter
    def creation_time(self, creation_time):
        """Sets the creation_time of this ApiHBaseSnapshot.

        Snapshot creation time.  # noqa: E501

        :param creation_time: The creation_time of this ApiHBaseSnapshot.  # noqa: E501
        :type: str
        """

        self._creation_time = creation_time

    @property
    def storage(self):
        """Gets the storage of this ApiHBaseSnapshot.  # noqa: E501


        :return: The storage of this ApiHBaseSnapshot.  # noqa: E501
        :rtype: Storage
        """
        return self._storage

    @storage.setter
    def storage(self, storage):
        """Sets the storage of this ApiHBaseSnapshot.


        :param storage: The storage of this ApiHBaseSnapshot.  # noqa: E501
        :type: Storage
        """

        self._storage = storage

    @property
    def storage_location(self):
        """Gets the storage_location of this ApiHBaseSnapshot.  # noqa: E501

        The remote location where a snapshot is stored. /*  Optional - location comes from HBase service config if this is not defined  # noqa: E501

        :return: The storage_location of this ApiHBaseSnapshot.  # noqa: E501
        :rtype: str
        """
        return self._storage_location

    @storage_location.setter
    def storage_location(self, storage_location):
        """Sets the storage_location of this ApiHBaseSnapshot.

        The remote location where a snapshot is stored. /*  Optional - location comes from HBase service config if this is not defined  # noqa: E501

        :param storage_location: The storage_location of this ApiHBaseSnapshot.  # noqa: E501
        :type: str
        """

        self._storage_location = storage_location

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ApiHBaseSnapshot, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApiHBaseSnapshot):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
