# ApiHiveReplicationArguments

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**source_service** | [**ApiServiceRef**](ApiServiceRef.md) |  | [optional] 
**table_filters** | [**list[ApiHiveTable]**](ApiHiveTable.md) | Filters for tables to include in the replication. Optional. If not provided, include all tables in all databases. | [optional] 
**export_dir** | **str** | Directory, in the HDFS service where the target Hive service&#x27;s data is stored, where the export file will be saved. Optional. If not provided, Cloudera Manager will pick a directory for storing the data. | [optional] 
**force** | **bool** | Whether to force overwriting of mismatched tables. Defaults to false. | [optional] 
**replicate_data** | **bool** | Whether to replicate table data stored in HDFS. Defaults to false. &lt;p/&gt; If set, the \&quot;hdfsArguments\&quot; property must be set to configure the HDFS replication job. | [optional] 
**hdfs_arguments** | [**ApiHdfsReplicationArguments**](ApiHdfsReplicationArguments.md) |  | [optional] 
**replicate_impala_metadata** | **bool** | Whether to replicate the impala metadata. (i.e. the metadata for impala UDFs and their corresponding binaries in HDFS). | [optional] 
**run_invalidate_metadata** | **bool** | Whether to run invalidate metadata query or not | [optional] 
**dry_run** | **bool** | Whether to perform a dry run. Defaults to false | [optional] 
**num_threads** | **int** | Number of threads to use in multi-threaded export/import phase | [optional] 
**sentry_migration** | **bool** |  | 
**skip_url_permissions** | **bool** | Is skipUrlPermissions on. | 
**atlas_replication_needed** | **bool** |  | [optional] 
**sentry_export_properties** | **dict(str, str)** | Additional properties to add or override in authorization-migration-site.xml for Sentry export, on the source. | [optional] 
**ranger_import_properties** | **dict(str, str)** | Additional properties to add or override in authorization-migration-site.xml for Ranger import, on the destination. | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

